# export-lib.pl
# Functions for linux autorpm

require '../web-lib.pl';
require '../software/rpm-lib.pl';
&init_config("autorpm");

sub list_opts
{
    # read the conf file
    local($rv, $_);
    if (-x "/etc/cron.hourly/autorpm") {
	$rv->{'period'} = "hourly";
    } elsif (-x "/etc/cron.daily/autorpm") {
	$rv->{'period'} = "daily";
    } elsif (-x "/etc/cron.weekly/autorpm") {
	$rv->{'period'} = "weekly";
    } elsif (-x "/etc/cron.monthly/autorpm") {
	$rv->{'period'} = "monthly";
    } else {
	$rv->{'period'} = "<font color=#ff0000>disabled</font>";
    } 
    $rv->{'firewall'} = "none";
    $rv->{'temp'} = "/var/spool/autorpm";
    $rv->{'report'} = "No one";
    open(CONF, $config{'autorpm_conf'});
    while(<CONF>) {
	s/\r|\n//g;
	if (/^ *\t*#/) {
	} elsif (/Firewall/) {
	    s/.*\( *"//;
	    s/" *\).*$//;
	    $rv->{'firewall'} = $_;
	} elsif (/Report_Queues_To/) {
	    s/.*\( *"//;
	    s/" *\).*$//;
	    $rv->{'report'} = $_;
	} elsif (/Temp_Dir/) {
	    s/.*\(//;
	    s/\).*$//;
	    $rv->{'temp'} = $_;
	}
    }
    close(CONF);
    return $rv;
}

sub list_URLs
{
    # read the conf file
    local(@rv, $_, $loc, $action, $mode, $new, $updated);
    $action = "";
    $accept = "all";
    $ignore = "none";
    $report = "No one";
    open(CONF, $config{'autorpm_conf'});
    while(<CONF>) {
	s/\r|\n//g;
	if (/^ *\t*#/) {
	} elsif (/ftp/ || /Directory/) {
	    s/.*\( *"//;
	    s/" *\).*$//;
	    $loc = $_;
	} elsif (/Report_To/) {
	    s/.*\( *"//;
	    s/" *\).*$//;
	    $report = $_;
	} elsif (/action/) {
	    s/.*\(//;
	    s/\).*$//;
	    $action = $_;
	} elsif (/Install/) {
	    s/.*\(//;
	    s/\).*$//;
	    $mode = $_;
	    ${$action} = $mode;
	} elsif (/Ignore/) {
	    s/.*\(//;
	    s/\).*$//;
	    $ignore = $_;
	} elsif (/Only/) {
	    s/.*\(//;
	    s/\).*$//;
	    $accept = $_;
        } elsif (/}/) {
            if ($action eq "") {
	        push(@rv, { 'url' => $loc,
			    'accept' => $accept,
			    'ignore' => $ignore,
			    'new' => $new,
			    'updated' => $updated,
			    'report' => $report});
	    } else {
		$action = "";
		$accept = "all";
		$ignore = "none";
		$report = "No one";
	    }
	}
    }
    close(CONF);
    return @rv;
}

sub list_queue
{
    # read the queue file
    local(@rv, $_, $lines, $line, $Source, $Delete, $Orig, $Flags, $Local, ,$AllowDelete,$CopyTo, $name, $new_file, $lnum);
    $lnum = 0;
    open(QUEUE, $config{'interactive_queue'});
    while (defined($line = <QUEUE>)) {
        unless ($lines{$line}) {
	    $lines{$line}++;
	    ($Source,$Delete,$Orig,$Flags,$Local,$AllowDelete,$CopyTo) = split (/;/,$line);
	    $Source =~ s/^\*//;
	    $Source =~ s/^\!//;
	    if (!$Orig) {
		$Orig = $Source;
	    }
	    $Flags =~ s/1:/requires /;
	    $Flags =~ s/2:/conflicts with /;
	    $Flags =~ s/^0:$//;
	    $Flags =~ s/^0$//;
	    if ($Flags eq "") {
		$Flags = "No error";
	    } else {
		$Flags = "<font color=#ff0000>$Flags</font>";
	    }
	    $name = BaseName ($Source);

	    if (! &package_info($name)) {
		$new_file .= $line;
		push(@rv, { 'source' => $Source,
			    'origin' => $Orig,
			    'error' => $Flags,
			    'name' => $name,
			    'local' => $Local,
		            'line' => $lnum});
		$lnum++;
	    }
	}
    }
    close(QUEUE);
    open(QUEUE, '>'.$config{'interactive_queue'});
    print QUEUE $new_file;
    close(QUEUE);
    return @rv;
}

sub BaseName($) {
    my $Temp = $_[0];
    $Temp =~ s#(.*/)?([^/]*-[^-]*-[^-]*)\..*\.rpm$#$2#;
    return ($Temp);
}



