#!/usr/bin/perl
###############################################################################
#    CD Backup - autobackup.pl
#
#    CD Backup for Webmin Module ver. 1.0
#    Copyright (C) 2000 by The Pretender <Sebastien J. Gross>
#    Bug reports to: seb@sjgross.com
#    Download:
#     http://www.freealter.com
#     http://www.sjgross.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#
###############################################################################

use CGI qw(:standard param);
do '../web-lib.pl';
require "../cron/cron-lib.pl";
&init_config();

#
# autoackup routine
#
sub exec_autobackup
{
  my $sel_date = param("ab_sel_date");
  my $last_change = param("ab_last_change");
  my $backup_dir = param("ab_directory");
  my $exclude_dir = param("exclude_dir");
  my $archive_name = param("ab_archive");
  my $act = param("act");
  my $cron = param("cron");
  my $ex_dir = "exclude.dir";

#  $ex_dirs = `pwd`.$ex_dirs;

  &header($text{'auto_backup_done'}, undef);
  print "<hr>\n";


  if ($act eq "activate")
  {
    open(DUMMY, ">/etc/cron.$cron/cdbackup");

    # Setup vars
    if ($exclude_dir)
    {
      $de = " --exclude-from $ex_dirs";
      $ex_dirs = `pwd`;
      $ex_dirs =~ s/\s+/\/$ex_dir/ ;
    }

    if ($sel_date)
    {
      # Update a backup
      $lc = " -mtime -$last_change ";
      $t = "-type";

      # As the `find' command can only retrive one type of file and can't exclude one
      # we have to make a backup for each type except directory
      print DUMMY "find $backup_dir $t b $lc | xargs tar cfz $archive_name-b $de\n";
      print DUMMY "find $backup_dir $t c $lc | xargs tar cfz $archive_name-c $de\n";
      print DUMMY "find $backup_dir $t f $lc | xargs tar cfz $archive_name-f $de\n";
      print DUMMY "find $backup_dir $t p $lc | xargs tar cfz $archive_name-p $de\n";
      print DUMMY "find $backup_dir $t f $lc | xargs tar cfz $archive_name-f $de\n";
      print DUMMY "find $backup_dir $t l $lc | xargs tar cfz $archive_name-l $de\n";
      print DUMMY "find $backup_dir $t s $lc | xargs tar cfz $archive_name-s $de\n";

    }
    else
    {
      # Full backup
      print DUMMY "tar cfz $archive_name $backup_dir $de\n";
    }
    close(DUMMY);
    system("chmod 755 /etc/cron.$cron/cdbackup");
    print "<h3>$text{'ab_activated'}</h3>\n";
  }
  else
  {
    system("rm /etc/cron.$cron/cdbackup");
    print "<h3>$text{'ab_desactivated'}</h3>\n";
  }
  print "<hr>\n";

  print "$text{'main_title'} $text{'version'}<br>\n";
  print "<a href=\"mailto:$text{'author_mail'}\">Sbastien J. Gross</a> - <a href=\"http://$text{'author_site'}\">$text{'author_site'}</a> --- <a href=\"http://$text{'company_site'}\">$text{'company'}</a><br>\n";

  &footer("", $text{'return_main'});

  return 1;
}
