#!/usr/bin/perl 

do "ldap_top.pl";
&connect ();
&ReadParse();

$level = ($in{level}) ? $in{level} : $config{base};
%allusers = show_level($config{usersdir},"one","objectclass=*");
%allgroups = show_level($config{groupdir},"one","objectclass=*");
$name = &cn_to_dn($in{dn}) if $in{dn};
if ($in{create}){
	if ($in{filename}){
		my (%hash,@lines,$create_error,$whatfailed);
		if ($in{urdnkey}){
			$hash{"dn"}[0] = $in{urdnkey} . "=" . $name . "," . $config{usersdir};
		} elsif ($in{grdnkey}) {
			$hash{"dn"}[0] = $in{grdnkey} . "=" . $name . "," . $config{groupdir};
		}
		open (FILE,"< " . $in{filename}) or error($text{open_err} . $in{filename});
		@lines = <FILE>;
		foreach $line (@lines){
			$key = &getLDIFkey($line);
			$value = &getLDIFval($line);
			if ($key eq "cn"){ 
				@words = &parse_ssv($in{dn});
				push @{$hash{$key}}, "\u$words[0] \u$words[1]";
			} elsif ($key eq "uid"){
				push @{$hash{$key}}, $name;
			}elsif ($key eq "initials"){
				push @{$hash{$key}}, &get_initials($in{dn});
			} elsif ($key eq "sn"){
				push @{$hash{$key}}, &get_sn($in{dn});
			} elsif ($key eq "givenname"){
				push @{$hash{$key}}, &get_gn($in{dn});
			} elsif ($key eq "mail" || $key eq "rfc822mailbox"){
				$str = $in{dn};
				$str =~ s/\s/\./;
				push @{$hash{$key}}, $str  . "@" . &get_mail_domain($value);
			} else {
				push @{$hash{$key}}, ($value);
			}
		}
		close FILE;
		$create_error = &create_user(\%hash);
		error($text{create_err} .  ": $create_error") if $create_error;
	} else {
		my (%hash,@arr,%koloms,$create_error,$whatfailed);
		@arr=parse_asv($in{selval});
		push (@arr,"objectclass");
		if ($in{urdnkey}) {
			%users = &show_level($config{usersdir},"one","objectclass=*");
		} elsif ($in{grdnkey}) {
			%users = &show_level($config{groupdir},"one","objectclass=*");
		}
		%koloms = &getkols();
		if (!scalar(%users)){
			error($in{msg_1});
		} else {
			foreach $dn (keys %users){
				foreach $key (keys %{$users{$dn}}){
					if (!exists ($koloms{$key})){
	        	        		push (@keys,$key);
					}
	                	}
	        	}
		}       
		%seen = ();
		foreach $item (@keys){
			push (@uniq,$item) unless $seen{$item}++;
		}
		if ($in{urdnkey}){
			$hash{"dn"}[0] = $in{urdnkey} . "=" . $name . "," . $config{usersdir};
		} elsif ($in{grdnkey}) {
			$hash{"dn"}[0] = $in{grdnkey} . "=" . &cn_no_spaces($in{dn}) . "," . $config{groupdir};
		}
		foreach $el (@uniq) {
			foreach $sel (@arr){
				if ($el eq $sel){
					if ($key eq "cn"){ 
						push @{$hash{$key}}, $in{dn};
					} elsif ($key eq "uid"){
						push @{$hash{$key}}, $name;
					}elsif ($key eq "initials"){
						push @{$hash{$key}}, get_initials($in{dn});
					} elsif ($key eq "sn"){
						push @{$hash{$key}}, get_sn($in{dn});
					} elsif ($key eq "givenname"){
						push @{$hash{$key}}, &get_gn($in{dn});
					} elsif ($key eq "mail" || $key eq "rfc822mailbox"){
						$str = $in{dn};
						$str =~ s/\s/\./;
						push @{$hash{$key}}, $str  . "@" . &get_mail_domain($value);
					} else {
						push @{$hash{$el}}, " ";
					}
				}
			}
		}
		foreach $key (keys %hash){
			foreach $value (@{$hash{$key}}){
			}
		}
		$create_error = &create_user(\%hash);
		error($in{create_err} . ": $create_error") if $create_error;
	}
	if ($in{urdnkey}) {
		$level = $in{urdnkey} . "=" . $name . "," . $config{usersdir};
	} elsif ($in{grdnkey}) {
		$level = $in{grdnkey} . "=" . &cn_no_spaces($in{dn}) . "," . $config{groupdir};
	}
}		

if ($in{checked}){
	my (%hash,$key,$value,$dn,$el,@arr,%seen);
	%seen = ();
	foreach $key (keys %in){
		if ($key ne "dn" && $key ne "checked"){
			@arr = &parse_asv($in{$key});
			foreach $el (@arr){
				if ($el eq "objectClass"){
					push @{$hash{"objectClass"}}, $key ;
				} else {
					push @{$hash{$el}}, " " unless $seen{$el}++ ;
				}
			}
		} else {
			$dn = &get_most_common(\%allusers) . "=" . $name . "," . $config{usersdir} if $in{urdnkey};
			$dn = &get_most_common(\%allgroups) . "=" . &cn_no_spaces($in{dn}) . "," . $config{groupdir} if $in{grdnkey};
		}
	
	}
	$hash{"dn"}[0] = $dn;
	$create_error = &create_user(\%hash);
	$level = $dn;
	error($in{create_err} . ": $create_error") if $create_error;
}		
		

$back = &go_back($level);
&header ("LDAP " . $text{usersgroups}, "", "edit", 1, 1);
print "<HR noshade size=2>\n";
if ($in{urdnkey}) {
	print "<P><B>LDAP " . $text{user} . " " . $text{credentials} . "@" . $level . "</B> ";
} elsif ($in{grdnkey}) {
	print "<P><B>LDAP " . $text{group} . " " . $text{credentials} . "@" . $level . "</B> ";
}
print "<P><A href=\"index.cgi?level=$back\">" . $text{back} . "</A></P>";
%list = &show_level($config{base},"subtree",&getRDN($level));
%koloms = &getkols();
print "<P>";
print "<FORM method=\"post\" action=\"show_entries.cgi?level=$level\">\n";
print "<TABLE border width=50% $cb>";
print "<TR $tb>";
print "<TD><B><DIV align=\"center\">" . $text{edit} . " " . $text{credentials} . "</DIV></B></TD>";
print "<TR>";
print "<TD><TABLE>";

if (!scalar(%list)) {
    print "<TR><TD><B>" . $text{msg_1} . "</B>";
}
else {
	foreach $key (keys %{$list{$level}}){
		if (!exists ($koloms{$key}) && $key ne &getRDNkey(&getRDN($level))){
        		foreach $value ( @{${$list{$level}}{$key}} ) {
        			if ($in{clear}){
					print "<TR><TD><B>". &ifblank($key) . "</B></TD>"; 
					print "<TD><INPUT type=\"text\" name=\"" . $key . "\" size=\"30\"></TD></TR>" ;
				} else {
					print "<TR><TD><B>". &ifblank($key) . "</B></TD>"; 
					print "<TD><INPUT type=\"text\" name=\"" . $key . "\" value=\"" . &ifblank($value) . "\" size=\"30\"></TD></TR>" ;
				}
			}
		}
	}
}
if ($in{add}) {
	print "<TR><TD><INPUT type=\"text\" name=\"key\" size=\"30\"></TD>"; 
	print "<TD><INPUT type=\"text\" name=\"value\" size=\"30\"></TD>";
	}
print "</TABLE>";
print "</TD>";
print "</TABLE>";
print "<TABLE width=50%><TR><TD align=\"left\">\n";
print "<TD align=\"left\"><INPUT type=\"submit\" name=\"save\" value=\"". $text{bu_save} . "\">\n";
print "</FORM>";
print "<FORM method=\"post\" action=\"edit_entries.cgi?level=$level\">\n";
if (!$in{add}){
print "<TD align=\"center\" valign=\"top\"><INPUT type=\"submit\" name=\"add\" value=\"" . $text{bu_add} . "\">\n";
}
print "<TD align=\"right\" valign=\"top\"><INPUT type=\"submit\" name=\"clear\" value=\"" . $text{bu_clear} . "\">\n";
print "</TABLE>";
print "</P>";
if (&getRDNkey(getRDN($level)) eq get_most_common(\%allusers)){
	print "<P><A href=\"assign.cgi?level=$level\">" . $text{assignln} . "</A></P>";
}

print "<BR>\n";
&footer ("/", "index");
do "footer.pl";

