#!/usr/bin/perl

#theme_prebody - called just before the main body of every page, so it can print any HTML it likes.
#theme_postbody - called just after the main body of every page.
#theme_header - called instead of the normal header function, with the same parameters. You could use this to re-write the header function in your own style with help and index links whereever you want them.
#theme_footer - called instead of the footer function with the same parameters.
#theme_error - called instead of the error function, with the same parameters.

%letter_sizes = (
	'100.png', [ 10, 16 ],
	'101.png', [ 11, 16 ],
	'102.png', [ 6, 16 ],
	'103.png', [ 10, 16 ],
	'104.png', [ 9, 16 ],
	'105.png', [ 4, 16 ],
	'106.png', [ 5, 16 ],
	'107.png', [ 9, 16 ],
	'108.png', [ 4, 16 ],
	'109.png', [ 14, 16 ],
	'110.png', [ 9, 16 ],
	'111.png', [ 11, 16 ],
	'112.png', [ 10, 16 ],
	'113.png', [ 10, 16 ],
	'114.png', [ 6, 16 ],
	'115.png', [ 8, 16 ],
	'116.png', [ 6, 16 ],
	'117.png', [ 9, 16 ],
	'118.png', [ 10, 16 ],
	'119.png', [ 13, 16 ],
	'120.png', [ 10, 16 ],
	'121.png', [ 10, 16 ],
	'122.png', [ 8, 16 ],
	'123.png', [ 7, 16 ],
	'124.png', [ 4, 16 ],
	'125.png', [ 7, 16 ],
	'126.png', [ 9, 16 ],
	'177.iso-8859-2.png', [ 10, 16 ],
	'179.iso-8859-2.png', [ 7, 16 ],
	'182.iso-8859-2.png', [ 9, 16 ],
	'188.iso-8859-2.png', [ 9, 16 ],
	'191.iso-8859-2.png', [ 9, 16 ],
	'192.png', [ 12, 16 ],
	'193.png', [ 12, 16 ],
	'194.png', [ 11, 16 ],
	'195.png', [ 12, 16 ],
	'196.png', [ 12, 16 ],
	'197.png', [ 12, 16 ],
	'198.png', [ 13, 16 ],
	'199.png', [ 12, 16 ],
	'200.png', [ 7, 16 ],
	'201.png', [ 8, 16 ],
	'202.png', [ 8, 16 ],
	'203.png', [ 7, 16 ],
	'204.png', [ 6, 16 ],
	'205.png', [ 5, 16 ],
	'206.png', [ 7, 16 ],
	'207.png', [ 7, 16 ],
	'208.png', [ 11, 16 ],
	'208.iso-8859-9.png', [ 13, 16 ],
	'209.png', [ 10, 16 ],
	'210.png', [ 13, 16 ],
	'211.png', [ 13, 16 ],
	'211.iso-8859-2.png', [ 13, 16 ],
	'212.png', [ 12, 16 ],
	'213.png', [ 13, 16 ],
	'214.png', [ 13, 16 ],
	'214.iso-8859-9.png', [ 13, 16 ],
	'215.png', [ 9, 16 ],
	'216.png', [ 13, 16 ],
	'217.png', [ 9, 16 ],
	'218.png', [ 9, 16 ],
	'219.png', [ 9, 16 ],
	'220.png', [ 9, 16 ],
	'220.iso-8859-9.png', [ 9, 16 ],
	'221.png', [ 11, 16 ],
	'221.iso-8859-9.png', [ 5, 16 ],
	'222.png', [ 9, 16 ],
	'222.iso-8859-9.png', [ 11, 16 ],
	'223.png', [ 9, 16 ],
	'224.png', [ 10, 16 ],
	'225.png', [ 10, 16 ],
	'226.png', [ 11, 16 ],
	'227.png', [ 10, 16 ],
	'228.png', [ 10, 16 ],
	'229.png', [ 11, 16 ],
	'230.png', [ 16, 16 ],
	'230.iso-8859-2.png', [ 9, 16 ],
	'231.png', [ 10, 16 ],
	'231.iso-8859-9.png', [ 10, 16 ],
	'231.iso.8859-9.png', [ 10, 16 ],
	'232.png', [ 11, 16 ],
	'233.png', [ 11, 16 ],
	'234.png', [ 11, 16 ],
	'234.iso-8859-2.png', [ 9, 16 ],
	'235.png', [ 11, 16 ],
	'236.png', [ 6, 16 ],
	'237.png', [ 6, 16 ],
	'238.png', [ 6, 16 ],
	'239.png', [ 7, 16 ],
	'240.png', [ 10, 16 ],
	'240.iso-8859-9.png', [ 10, 16 ],
	'241.png', [ 9, 16 ],
	'241.iso-8859-2.png', [ 9, 16 ],
	'242.png', [ 11, 16 ],
	'243.png', [ 11, 16 ],
	'243.iso-8859-2.png', [ 11, 16 ],
	'244.png', [ 11, 16 ],
	'245.png', [ 11, 16 ],
	'246.png', [ 11, 16 ],
	'246.iso-8859-9.png', [ 11, 16 ],
	'247.png', [ 9, 16 ],
	'248.png', [ 10, 16 ],
	'249.png', [ 9, 16 ],
	'250.png', [ 9, 16 ],
	'251.png', [ 9, 16 ],
	'252.png', [ 9, 16 ],
	'252.iso-8859-9.png', [ 9, 16 ],
	'253.png', [ 10, 16 ],
	'253.iso-8859-9.png', [ 5, 16 ],
	'254.png', [ 10, 16 ],
	'255.png', [ 9, 16 ],
	'32.png', [ 6, 16 ],
	'33.png', [ 4, 16 ],
	'34.png', [ 7, 16 ],
	'35.png', [ 9, 16 ],
	'36.png', [ 8, 16 ],
	'37.png', [ 13, 16 ],
	'38.png', [ 11, 16 ],
	'39.png', [ 3, 16 ],
	'40.png', [ 6, 16 ],
	'41.png', [ 6, 16 ],
	'42.png', [ 7, 16 ],
	'43.png', [ 9, 16 ],
	'44.png', [ 4, 16 ],
	'45.png', [ 6, 16 ],
	'46.png', [ 4, 16 ],
	'47.png', [ 7, 16 ],
	'48.png', [ 9, 16 ],
	'49.png', [ 6, 16 ],
	'50.png', [ 9, 16 ],
	'51.png', [ 9, 16 ],
	'52.png', [ 10, 16 ],
	'53.png', [ 9, 16 ],
	'54.png', [ 10, 16 ],
	'55.png', [ 8, 16 ],
	'56.png', [ 9, 16 ],
	'57.png', [ 10, 16 ],
	'58.png', [ 5, 16 ],
	'59.png', [ 4, 16 ],
	'60.png', [ 9, 16 ],
	'61.png', [ 10, 16 ],
	'62.png', [ 10, 16 ],
	'63.png', [ 9, 16 ],
	'64.png', [ 12, 16 ],
	'65.png', [ 12, 16 ],
	'66.png', [ 9, 16 ],
	'67.png', [ 12, 16 ],
	'68.png', [ 10, 16 ],
	'69.png', [ 7, 16 ],
	'70.png', [ 7, 16 ],
	'71.png', [ 13, 16 ],
	'72.png', [ 9, 16 ],
	'73.png', [ 5, 16 ],
	'74.png', [ 8, 16 ],
	'75.png', [ 9, 16 ],
	'76.png', [ 8, 16 ],
	'77.png', [ 12, 16 ],
	'78.png', [ 10, 16 ],
	'79.png', [ 12, 16 ],
	'80.png', [ 9, 16 ],
	'81.png', [ 13, 16 ],
	'82.png', [ 9, 16 ],
	'83.png', [ 9, 16 ],
	'84.png', [ 8, 16 ],
	'85.png', [ 9, 16 ],
	'86.png', [ 11, 16 ],
	'87.png', [ 14, 16 ],
	'88.png', [ 11, 16 ],
	'89.png', [ 11, 16 ],
	'90.png', [ 9, 16 ],
	'91.png', [ 5, 16 ],
	'93.png', [ 6, 16 ],
	'94.png', [ 9, 16 ],
	'95.png', [ 9, 16 ],
	'96.png', [ 6, 16 ],
	'97.png', [ 11, 16 ],
	'98.png', [ 10, 16 ],
	'99.png', [ 10, 16 ]
	);




sub theme_header {
	local @available = ("webmin", "system", "servers", "cluster", "hardware", "", "net", "kororaweb");

	local $ll;
	local %access = &get_module_acl();
	local %gaccess = &get_module_acl(undef, "");
	print "<!doctype html public \"-//W3C//DTD HTML 3.2 Final//EN\">\n";
	print "<html>\n";
	print '<style type="text/css"><!-- @import url(/mandriva.css); --></style>';
	local $os_type = $gconfig{'real_os_type'} ? $gconfig{'real_os_type'}
		: $gconfig{'os_type'};
	local $os_version = $gconfig{'real_os_version'} ? $gconfig{'real_os_version'}
		: $gconfig{'os_version'};
	print "<head>\n";
	if ($charset) {
		print "<meta http-equiv=\"Content-Type\" content=\"text/html; Charset=$charset\">\n";
	}
	print "<link rel='icon' href='/images/webmin_icon.png' type='image/png'>\n";
	if (@_ > 0) {
		if ($gconfig{'sysinfo'} == 1) {
			printf "<title>%s : %s on %s (%s %s)</title>\n",
				$_[0], $remote_user, &get_display_hostname(),
				$os_type, $os_version;
		}
		elsif ($gconfig{'sysinfo'} == 4) {
			printf "<title>%s on %s (%s %s)</title>\n",
				$remote_user, &get_display_hostname(),
				$os_type, $os_version;
		}
		else {
			print "<title>$_[0]</title>\n";
		}
		print $_[7] if ($_[7]);
		if ($gconfig{'sysinfo'} == 0 && $remote_user) {
			print "<SCRIPT LANGUAGE=\"JavaScript\">\n";
			printf
			"defaultStatus=\"%s%s logged into %s %s on %s (%s %s)\";\n",
				$ENV{'ANONYMOUS_USER'} ? "Anonymous user" : $remote_user,
				$ENV{'SSL_USER'} ? " (SSL certified)" :
				$ENV{'LOCAL_USER'} ? " (Local user)" : "",
			$text{'programname'},
				&get_webmin_version(), &get_display_hostname(),
				$os_type, $os_version;
			print "</SCRIPT>\n";
		}
	}

	@modules = &get_visible_module_infos()
		if (!defined(@modules));

	print "</head>\n";
	if ($theme_no_table) {
		print '<body bgcolor=#2b3b7c background="images/background.jpg" link=#000000 vlink=#000000 leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" '.$_[8].'>';
	}
	else {
		print '<body bgcolor=#2b3b7c background="images/background.jpg" link=#000000 vlink=#000000 leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" '.$_[8].'>';
	}

	if ($remote_user && @_ > 1) {
		# Show basic header with webmin.com link and logout button
		local $logout = $main::session_id ? "/session_login.cgi?logout=1"
			: "/switch_user.cgi";
		local $loicon = $main::session_id ? "logout.png" : "switch.png";
		local $lowidth = $main::session_id ? 84 : 27;
		local $lotext = $main::session_id ? $text{'main_logout'}
			: $text{'main_switch'};
		print qq~<div id="toolbar"><table width="100%" border="0" cellspacing="0" cellpadding="0" background="$gconfig{'webprefix'}/images/top_bar/bg.png" height="32">
		<tr>
			<td width="4" nowrap><img src="$gconfig{'webprefix'}/images/top_bar/left.png" width="4" height="32"></td>
			<td width="100%" nowrap><a href="http://www.webmin.com"><img src="$gconfig{'webprefix'}/images/top_bar/webmin_logo.png" width="99" height="32" border="0" alt="Webmin home page"></a></td>~;
		if (!$ENV{'ANONYMOUS_USER'}) {
			if ($gconfig{'nofeedbackcc'} != 2 && $gaccess{'feedback'} &&
				(!$module_name || $module_info{'longdesc'} || $module_info{'feedback'})) {
				print qq~<td><a href='/feedback_form.cgi?module=$module_name'><img src=$gconfig{'webprefix'}/images/top_bar/feedback.png width=97 height=32 alt="$text{'main_feedback'}" border=0></a></td>~;
			}
			if (!$ENV{'SSL_USER'} && !$ENV{'LOCAL_USER'} &&
				!$ENV{'HTTP_WEBMIN_SERVERS'}) {
				if ($gconfig{'nofeedbackcc'} != 2 &&
					$gaccess{'feedback'}) {
					print qq~<td><img src=$gconfig{'webprefix'}/images/top_bar/top_sep.png width=12 height=32></td>~;
				}
				print qq~<td width="84" nowrap><a href='$logout'><img src="$gconfig{'webprefix'}/images/top_bar/$loicon" height="31" width=$lowidth border="0" alt="$lotext"></a></td>~;
			}
		}
		print qq~<td width="3" nowrap>
			<div align="right"><img src="$gconfig{'webprefix'}/images/top_bar/right.png" width="3" height="32"></div>
			</td>
		</tr>
		</table>~;
	}

	local $one = @modules == 1 && $gconfig{'gotoone'};
	local $notabs = $gconfig{"notabs_${base_remote_user}"} == 2 ||
		$gconfig{"notabs_${base_remote_user}"} == 0 && $gconfig{'notabs'};
	if (@_ > 1 && !$one && $remote_user && !$notabs) {
		# Display module categories
		print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0" height="7">
	<tr>
		<td background="$gconfig{'webprefix'}/images/top_bar/shadow_bg.png" nowrap><img src="$gconfig{'webprefix'}/images/top_bar/shadow.png" width="8" height="7"></td>
	</tr>
	</table>~;

		local %catnames;
		&read_file("$config_directory/webmin.catnames", \%catnames);
		foreach $m (@modules) {
			local $c = $m->{'category'};
			next if ($cats{$c});
			if (defined($catnames{$c})) {
				$cats{$c} = $catnames{$c};
			}
			elsif ($text{"category_$c"}) {
				$cats{$c} = $text{"category_$c"};
			}
			else {
				# try to get category name from module ..
				local %mtext = &load_language($m->{'dir'});
				if ($mtext{"category_$c"}) {
					$cats{$c} = $mtext{"category_$c"};
				}
				else {
					$c = $m->{'category'} = "";
					$cats{$c} = $text{"category_$c"};
				}
			}
		}
		@cats = sort { $b cmp $a } keys %cats;
		$cats = @cats;
		$per = $cats ? 100.0 / $cats : 100;

		if ($theme_index_page) {
			if (!defined($in{'cat'})) {
			
			# Use default category
			if (defined($gconfig{'deftab'}) &&
				&indexof($gconfig{'deftab'}, @cats) >= 0) {
				$in{'cat'} = $gconfig{'deftab'};
			}
			else {
				$in{'cat'} = $cats[0];
			}
		}
		elsif (!$cats{$in{'cat'}}) {
			$in{'cat'} = "";
		}
	}

	#####Navigation Bar START#####
	print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0" height="57" background="$gconfig{'webprefix'}/images/nav/bg.png">
	<tr background="$gconfig{'webprefix'}/images/nav/bg.png">
		<td width="6" nowrap><img src="$gconfig{'webprefix'}/images/nav/left.png" width="3" height="57"></td>~;

	foreach $c (@cats) {
		local $t = $cats{$c};
		$inlist	= "false";
		foreach $testet (@available) {
			if ($testet eq $c) {
				$inlist = "true";
			} 
		}
		if ($in{'cat'} eq $c && $theme_index_page) {
			if ($inlist eq "true") {

				if ($c eq "") {
					print qq~<td nowrap><center><img src="$gconfig{'webprefix'}/images/cats_over/others.png" width="43" height="44"><br>~;
					&chop_font;

					print qq~</center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~; 
				}
				elsif ($c eq "webmin") {
					if (@_ > 1) {
						print qq~<td nowrap><center><a href=$gconfig{'webprefix'}/?cat=$c><img src="$gconfig{'webprefix'}/images/cats_over/$c.png" width="43" height="44" border=0><br>~;
						&chop_font;
						print qq~</a></center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~;
					}
					else {
						print qq~<td nowrap><center><img src="$gconfig{'webprefix'}/images/cats_over/$c.png" width="43" height="44" border=0><br>~;
						&chop_font;
						print qq~</center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~;
					}
				}
				else {
					print qq~<td nowrap><center><img src="$gconfig{'webprefix'}/images/cats_over/$c.png" width="43" height="44"><br>~;
					&chop_font;
					print qq~</center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~;
				}
			}
			else {
				print qq~<td nowrap><center><img src="$gconfig{'webprefix'}/images/cats_over/unknown.png" width="43" height="44"><br>~;
				&chop_font;
				print qq~</center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~;
			}
		}
		else {
			if ($inlist eq "true") {
				if ($c eq "") {
					print qq~<td nowrap><center><a href=$gconfig{'webprefix'}/?cat=$c><img src="$gconfig{'webprefix'}/images/cats/others.png" width="43" height="44" border=0 alt="$t"><br>~;
					&chop_font;
					print qq~</a></center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~; 
				}
				else {
					print qq~<td nowrap><a href=$gconfig{'webprefix'}/?cat=$c><center><img src="$gconfig{'webprefix'}/images/cats/$c.png" width="43" height="44" border=0 alt="$t"><br>~;
					&chop_font;
					print qq~</a></center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~;
				}
			}
			else {
				print qq~<td nowrap><center><a href=$gconfig{'webprefix'}/?cat=$c><img src="$gconfig{'webprefix'}/images/cats/unknown.png" width="43" height="44" border=0 alt="$t"><br>~;
				&chop_font;
				print qq~</a></center></td>
	<td width="17" nowrap><img src="$gconfig{'webprefix'}/images/nav/sep.png" width="17" height="57"></td>~;
			}
		}
	}

	print qq~<td width="100%" nowrap>&nbsp;</td>
	<td nowrap>&nbsp;</td>
	</tr>
	</table>~;
	print qq~
	<table width="100%" border="0" cellspacing="0" cellpadding="0" background="$gconfig{'webprefix'}/images/nav/bottom_bg.png" height="4">
	<tr>
		<td width="100%"><img src="$gconfig{'webprefix'}/images/nav/bottom_left.png" width="3" height="4"></td>
	</tr>
	</table>
	~;
	}

	if (@_ > 1 && (!$_[5] || $ENV{'HTTP_WEBMIN_SERVERS'})) {
		# Show tabs under module categories
		print qq~
		<table width="100%" border="0" cellspacing="0" cellpadding="0"> <tr>~;

		if ($gconfig{'sysinfo'} == 2 && $remote_user) {
			&tab_start();
			printf "%s%s logged into %s %s on %s (%s%s)</td>\n",
				$ENV{'ANONYMOUS_USER'} ? "Anonymous user" : "<tt>$remote_user</tt>",
				$ENV{'SSL_USER'} ? " (SSL certified)" :
				$ENV{'LOCAL_USER'} ? " (Local user)" : "",
				$text{'programname'},
				$version, "<tt>".&get_display_hostname()."</tt>",
				$os_type, $os_version eq "*" ? "" : " $os_version";
			&tab_end();
		}
		if ($ENV{'HTTP_WEBMIN_SERVERS'}) {
			&tab_start();
			print "<a href='$ENV{'HTTP_WEBMIN_SERVERS'}'>",
				"$text{'header_servers'}</a><br>\n";
			&tab_end();
		}
		if ($notabs && !$_[5]) { 
			&tab_start;
			print "<a href='$gconfig{'webprefix'}/?cat=$module_info{'category'}'>$text{'header_webmin'}</a><br>\n";
			&tab_end;
		}
		if (!$_[4]) {
			local $idx = $module_info{'index_link'};
			local $mi = $module_index_link ||
					$module_name ? "/$module_name/$idx" : "/";
			&tab_start; print "<a href=\"$gconfig{'webprefix'}$mi\">",
					"$text{'header_module'}</a>"; &tab_end;
		}
		if (ref($_[2]) eq "ARRAY" && !$ENV{'ANONYMOUS_USER'}) {
			&tab_start; print &hlink($text{'header_help'}, $_[2]->[0], $_[2]->[1]); &tab_end;
		}
		elsif (defined($_[2]) && !$ENV{'ANONYMOUS_USER'}) {
			&tab_start; print &hlink($text{'header_help'}, $_[2]); &tab_end;
		}
		if ($_[3]) {
			if (!$access{'noconfig'}) {
				&tab_start; print "<a href=\"/config.cgi?$module_name\">",
					$text{'header_config'},"</a>"; &tab_end;
			}
		}

		local $t;
		foreach $t (split(/<br>/, $_[6])) {
			if ($t =~ /\S/) {
				&tab_start;
				print $t;
				&tab_end;
			}
		}

		print qq~
		<td nowrap width="100%" valign="top">&nbsp;</td>
	</tr>
	</table>
	</div>
	~;

		if (!$_[5]) {
			# Show page title
			local $title = $_[0];
			$title =~ s/&auml;//g;
			$title =~ s/&ouml;//g;
			$title =~ s/&uuml;//g;
			$title =~ s/&nbsp;/ /g;

			print '<div id="module">';
	
			print "<p><table border=0 cellpadding=0 cellspacing=0 width=95% align=center><tr><td><table border=0 cellpadding=0 cellspacing=0 height=20><tr>\n";
			print "<td>&nbsp;<b><div id=\"title\">$title</div></b>&nbsp;</td>\n";
			if ($_[9]) {
				print "</tr></table></td> <td align=right><table border=0 cellpadding=0 cellspacing=0 height=20><tr>\n";
				print "<td>&nbsp;<b><div id=\"title\">$_[9]</div></b>&nbsp;</td>\n";
			}
			print "</tr></table></td></tr></table>"; 

			&theme_prebody;
		}
	}
	elsif (@_ > 1) {
		print "</div>";
	}
	@header_arguments = @_;
}

sub theme_prebody
{
	if ($theme_no_table) {
		print "<ul>\n";
	}
	else {
		print "<table border=0 width=95% align=center cellspacing=0 cellpadding=0><tr><td>\n";
		print "<table border=0 width=95% align=center cellspacing=0 cellpadding=0><tr><td>\n";
	}
}

sub theme_footer {
	local $i;

	if ($theme_no_table) {
		print "</ul>\n";
	}
	elsif (@header_arguments > 1 && !$header_arguments[5]) {
		print "</table></table><br>\n";
	}

	print "<table border=0 cellspacing=0 cellpadding=0><tr><td align=\"left\">\n";

	for($i=0; $i+1<@_; $i+=2) {
		local $url = $_[$i];
		if ($url eq '/') {
			$url = "/?cat=$module_info{'category'}";
		}
		elsif ($url eq '' && $module_name) {
			local $idx = $module_info{'index_link'};
			$url = "/$module_name/$idx";
		}
		elsif ($url =~ /^\?/ && $module_name) {
			$url = "/$module_name/$url";
		}
		if ($i == 0) {
			print "&nbsp;<a href=\"$url\" class=\"footer\">";
			print "<img alt=\"<-\" border=0 src=$gconfig{'webprefix'}/images/arrow.png>\n";
			print "</a>";
		}
		else {
			print "&nbsp;\n";
		}
		print "</td><td>";
		print "&nbsp;<a href=\"$url\" class=\"footer\">",&text('main_return', $_[$i+1]),"</a>\n";
	}
	print "</td></tr></table>\n";

	print "<br>\n";
	if (!$_[$i]) {
		if (defined(&theme_postbody)) {
			&theme_postbody(@_);
		}
		print "</div></body></html>\n";
	}
}

sub chop_font {
	if (!$current_lang_info->{'titles'} || $gconfig{'texttitles'}) {
		print $t;
	}
	else {
		foreach $l (split(//, $t)) {
			$ll = ord($l);
			local $gif;
			if ($ll > 127 && $current_lang_info->{'charset'}) {
				$gif = "$ll.$current_lang_info->{'charset'}.png";
			}
			else {
				$gif = "$ll.png";
			}
			local $sz = $letter_sizes{$gif};
			printf "<img src=$gconfig{'webprefix'}/images/letters2/%s width=%d height=%d alt=\"%s\" align=bottom border=0>",
			$gif, $sz->[0], $sz->[1], $ll eq " " ? "&nbsp;" : $l;
		}
	}
}

sub tab_start {
	print qq~	<td nowrap>
	<table border="0" cellspacing="0" cellpadding="0">
		<tr>
		<td><img src="$gconfig{'webprefix'}/images/tabs/left.png" width="12" height="21" nowrap></td>
		<td background="$gconfig{'webprefix'}/images/tabs/bg.png" nowrap>~;
}


sub tab_end {
	 print qq~</td>
		<td nowrap><img src="$gconfig{'webprefix'}/images/tabs/right.png" width="15" height="21"></td>
		</tr>
		<tr>
		<td nowrap><img src="$gconfig{'webprefix'}/images/tabs/right_bottom.png" width="12" height="4"></td>
		<td width="100%" background="$gconfig{'webprefix'}/images/tabs/bottom.png" nowrap></td>
		<td nowrap><img src="$gconfig{'webprefix'}/images/tabs/left_bottom.png" width="15" height="4"></td>		</tr>
	</table>

	</td>~;
}

# generate_icon(image, title, link, [href], [width], [height])
sub theme_generate_icon
{
	&load_theme_library();
	$icon = $_[0];
	$icon =~ s/\.gif$/\.png/g;
	local $module = `basename \$(pwd)`;
	chop($module);
	if (not -e "/usr/share/webmin/mandriva/$module/$icon") {
		$icon =~ s/\.png$/\.gif/g;
	}
	local $w = !defined($_[4]) ? "width=48" : $_[4] ? "width=$_[4]" : "";
	local $h = !defined($_[5]) ? "height=48" : $_[5] ? "height=$_[5]" : "";
	if ($tconfig{'noicons'}) {
		if ($_[2]) {
			print "<a href=\"$_[2]\">$_[1]</a>\n";
		}
		else {
			print "$_[1]\n";
		}
	}
	elsif ($_[2]) {
		print "<table border=0><tr><td width=48 height=48>\n",
			"<a href=\"$_[2]\" $_[3]><img src=\"$icon\" alt=\"\" border=0 ",
			"$w $h></a></td></tr></table>\n";
		print "<a href=\"$_[2]\">$_[1]</a>\n";
	}
	else {
		print "<table border=0><tr><td width=48 height=48>\n",
			"<img src=\"$icon\" alt=\"\" border=0 $w $h>",
			"</td></tr></table>\n$_[1]\n";
	}
}


1;

# vim: ts=4:sw=4
