#!/usr/bin/perl
#
# $Id: access.cgi,v 1.6 2000/12/20 09:08:31 seb Exp $
# Main screen for edition of access control lists
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
require './parse_slapd_conf.pl';
my @backends = parse_slapd_conf( $config{slapd_conf_file} );
my $cbackend = $backends[$in{b}];


sub print_who_access {
    my( $who, $access ) = @_;

    my( $type, $val) = split( /=/, $who, 2);
    $val =~ s/\s*"?([^"]*)"?\s*/$1/;

    my $self = ($access =~ /^self/ ? "$text{access_self} " : '');
    $access =~ s/^self//;

    printf "<tr><td>$text{by} %s%s</td>", $text{"access_type_$type"}, ($val?" \"$val\"":"");
    printf '<td align=right>%s%s</td></tr>', $self, $text{"access_$access"};
}

header( $text{index_title}, undef, undef, 1, undef, undef, $text{index_right} );
print "<center><b>$text{access_title} \"$cbackend->{suffix}\" ($cbackend->{type})";
print "</b></center><hr>\n";

for my $i ( 0..$#{$cbackend->{access}} ) {
    print "<table width=100% border>\n";
    printf '<tr %s><td width=85%><b>%s %s</b></td>', $tb, $text{access_to},
           join( ' ', ($cbackend->{access}[$i][0], $cbackend->{access}[$i][1]) );
    print '<td width=15% align=center>&nbsp;';
    if( $i == 0 ){
        print $text{access_up};
    }
    else {
        printf '<a href="access_move.cgi?b=%d&a=%d&way=u">%s</a>', $in{b}, $i, $text{access_up};
    }
    print "&nbsp;|&nbsp;";
    if( $i == $#{$cbackend->{access}} ){
        print $text{access_down};
    }
    else {
        printf '<a href="access_move.cgi?b=%d&a=%d&way=d">%s</a>', $in{b}, $i, $text{access_down};
    }
    printf '&nbsp;|&nbsp;<a href="access_edit.cgi?b=%d&a=%d">%s</a>&nbsp;|', $in{b}, $i, $text{access_edit};
    printf '&nbsp;<a href="access_add.cgi?b=%d&before=%d">%s</a>&nbsp;', $in{b}, $i, $text{access_insert};
    print "</td></tr>\n";
    print "<tr $cb><td colspan=2><table width=100% border=0>\n";

    for( my $j=2; $j<$#{$cbackend->{access}[$i]}; $j+=2 ) {
	print_who_access( $cbackend->{access}[$i][$j], $cbackend->{access}[$i][$j+1] );
    }
    print "</table></td></tr></table><br>\n";
}

print "<br><a href=access_add.cgi?b=$in{b}>$text{access_new}</a><br>\n";

print "<hr>\n";
footer( $in{b} ? "backend.cgi?b=$in{b}" : 'index.cgi', $text{access_back} );
