#!/usr/bin/perl
#
# $Id: access_save.cgi,v 1.4 2000/12/17 19:52:30 seb Exp $
# Script that performs most of saving for access control lists
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
require './parse_slapd_conf.pl';

my @backends = parse_slapd_conf( $config{slapd_conf_file} );

error_setup( $text{access_save_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b} );


if( $in{save_access} ){
    my $acl = $backends[$in{b}]{access}[$in{access}];
    for( my $i=2; $i<$in{nb_who}; $i+=2 ){
	$in{"val_$i"} = '' if $in{"who_$i"} eq '*' || $in{"who_$i"} eq 'self';
	$acl->[$i]    = $in{"who_$i"} . ($in{"val_$i"} ? '="' . $in{"val_$i"} . '"' : '');
	$acl->[$i+1]  = $in{"self_$i"} . $in{"access_$i"};
    }
    write_slapd_conf( $config{slapd_conf_file}, \@backends );
    redirect( "access.cgi?b=$in{b}" );
}

elsif( $in{add_newwho} ){
    my $acl = $backends[$in{b}]{access}[$in{access}];
    $in{val_newwho} = '' if $in{who_newwho} eq '*' || $in{who_newwho} eq 'self';
    push @$acl, $in{who_newwho} . ($in{val_newwho} ? "=\"$in{val_newwho}\"" : '');
    push @$acl, $in{access_newwho};
    write_slapd_conf( $config{slapd_conf_file}, \@backends );
    redirect( "access_edit.cgi?b=$in{b}&a=$in{access}" );
}

elsif( $in{del_access} ){
    splice @{$backends[$in{b}]{access}}, $in{access}, 1;
    write_slapd_conf( $config{slapd_conf_file}, \@backends );
    redirect( "access.cgi?b=$in{b}" );
}

elsif( $in{new_access} ){
    my $what = $in{what} . ($in{what} =~ /^dn|filter$/ ? "=\"$in{val_what}\"" : '');
    $in{attributes} =~ s/ //g;
    $in{attributes} = 'entry' . ($in{attributes} ? ',' : '') . $in{attributes} if $in{entry};
    $in{attributes} = 'attribute=' . $in{attributes} if $in{attributes};

    if( defined $in{before} ){
	splice( @{$backends[$in{b}]{access}}, $in{before}, 0,
		[ $what, $in{attributes}, '*', $backends[$in{b}]{defaultaccess} || 'None' ] );
    }
    else {
	push @{$backends[$in{b}]{access}}, [ $what, $in{attributes},
					     '*', $backends[$in{b}]{defaultaccess} || 'None' ];
	$in{before} = $#{$backends[$in{b}]{access}};
    }
    write_slapd_conf( $config{slapd_conf_file}, \@backends );
    redirect( "access_edit.cgi?b=$in{b}&a=$in{before}" );
}

else {
    for( my $i=0; $i<$in{nb_who}; $i+=2 ){
	if( defined $in{"del_$i"} ){
	    my $acl = $backends[$in{b}]{access}[$in{access}];
	    splice @$acl, $i, 2;
	    write_slapd_conf( $config{slapd_conf_file}, \@backends );
	    redirect( "access_edit.cgi?b=$in{b}&a=$in{access}" );
	}
    }
}
