#!/usr/bin/perl
#
# $Id: at_edit.cgi,v 1.4 2000/12/17 19:52:30 seb Exp $
# Screen for the edition of an attribute
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{at_edit_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b} );

print_header( $text{at_edit_title}, $file, $type, $suffix );

print "<form method=post action=at_save.cgi>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<input type=hidden name=at value=\"$in{at}\">\n<table width=100% border>\n";
print "<tr $tb><td><b>$text{at} $in{at}</b></td></tr><tr $cb><td><table width=100% border=0>\n";

$nb = $#{$cbackend->{attribute}{$in{at}}};
print "<tr><td><b>$text{at_alternates}</b></td><td><input name=alternates size=50 value=\"";
print $nb ? join( ' ', @{$cbackend->{attribute}{$in{at}}}[0..$nb-1] ) : '', "\"></td></tr>\n";
print "<tr><td><b>$text{at_syntax}</b></td><td>";

print list_input( 'syntax',
		  [ $text{at_bin}, $text{at_ces}, $text{at_cis}, $text{at_tel}, $text{at_dn} ],
		  [ 'bin',         'ces',         'cis',         'tel',         'dn' ],
		  $cbackend->{attribute}{$in{at}}[$nb] );

print "</td></tr><tr><td><input type=submit name=del_at value=\"$text{at_edit_delete}\">\n";
print "&nbsp;&nbsp;<input type=submit name=mod_at value=\"$text{at_edit_save}\"></td></tr>\n";
print "</table></td></tr></table></form>\n";

footer( "at.cgi?b=$in{b}&i=$in{i}", $text{at_edit_back} );
