#!/usr/bin/perl
#
# $Id: oc_edit.cgi,v 1.5 2000/12/18 09:03:27 seb Exp $
# Screen for the edition of an object class
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{oc_edit_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b}, $in{i} );

print_header( $text{oc_title}, $file, $type, $suffix );

print "<table width=100%><tr valign=top>\n";
print "<td><h3>$text{oc_edit_title} \"$in{oc}\"</h3>\n<i>$text{oc_edit_explain}</i></td>";
print "<td align=right><form action=oc_save.cgi method=post>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<input type=hidden name=oc value=$in{oc}>\n";
print "<input type=submit name=del_oc value=\"$text{oc_edit_delete}\">\n";
print "</form></td></tr></table>\n";

print "<table width=100%><tr valign=top>\n";

print "<td width=49%><table width=100% border><tr $tb><td><b>$text{oc_requires}</b></td></tr>\n";
print "<tr $cb><td>";
for my $i ( 0 .. $#{$cbackend->{objectclass}{$in{oc}}{requires}} ){
    print "<a href=\"oc_save.cgi?b=$in{b}&i=$in{i}&oc=$in{oc}&del_at_requires=$i\">";
    print "$cbackend->{objectclass}{$in{oc}}{requires}[$i]</a><br>\n";
}
print "</td></tr></table></td>\n";

print "<td width=2%>&nbsp;</td>\n";

print "<td width=49%><table width=100% border><tr $tb><td><b>$text{oc_allows}</b></td></tr>\n";
print "<tr $cb><td>";
for my $i ( 0 .. $#{$cbackend->{objectclass}{$in{oc}}{allows}} ){
    print "<a href=\"oc_save.cgi?b=$in{b}&i=$in{i}&oc=$in{oc}&del_at_allows=$i\">";
    print "$cbackend->{objectclass}{$in{oc}}{allows}[$i]</a><br>\n";
}
print "</td></tr></table></td>\n";

print "</tr></table><hr>\n";

print "<h3>$text{oc_edit_add_title}</h3>\n";
print "<form action=oc_save.cgi method=post>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<input type=hidden name=oc value=$in{oc}>\n";
print "<input name=at>&nbsp;&nbsp;";
print "<input type=radio name=type value=requires> $text{oc_requires}&nbsp;";
print "<input type=radio name=type value=allows checked> $text{oc_allows}&nbsp;&nbsp;";
print "<input type=submit name=add_at value=\"$text{oc_edit_add}\">\n";
print "</form><hr>\n";

footer( "oc.cgi?b=$in{b}&i=$in{i}", $text{oc_edit_back} );
