#!/usr/bin/perl
#
# $Id: oc_save.cgi,v 1.4 2000/12/17 19:52:30 seb Exp $
# This CGI does the most of object classes saving
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{oc_save_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b}, $in{i} );

if( defined $in{del_at_allows} ){
    splice @{$cbackend->{objectclass}{$in{oc}}{allows}}, $in{del_at_allows}, 1;
    write_slapd_conf( $file, $backends );
    redirect( "oc_edit.cgi?b=$in{b}&i=$in{i}&oc=$in{oc}" );                                             
}

if( defined $in{del_at_requires} ){
    splice @{$cbackend->{objectclass}{$in{oc}}{requires}}, $in{del_at_requires}, 1;
    write_slapd_conf( $file, $backends );
    redirect( "oc_edit.cgi?b=$in{b}&i=$in{i}&oc=$in{oc}" );
}

elsif( defined $in{add_at} ){
    push @{$cbackend->{objectclass}{$in{oc}}{$in{type}}}, $in{at};
    write_slapd_conf( $file, $backends );
    redirect( "oc_edit.cgi?b=$in{b}&i=$in{i}&oc=$in{oc}" );
}

elsif( defined $in{del_oc} ){
    delete $cbackend->{objectclass}{$in{oc}};
    write_slapd_conf( $file, $backends );
    redirect( "oc.cgi?b=$in{b}&i=$in{i}" );
}

elsif( defined $in{add_oc} ){
    $cbackend->{objectclass}{$in{oc}} = { requires => [ 'top' ], allows => [] };
    write_slapd_conf( $file, $backends );
    redirect( "oc_edit.cgi?b=$in{b}&i=$in{i}&oc=$in{oc}" );
}

else {
    redirect( "oc_edit.cgi?b=$in{b}" );
}

