#!/usr/bin/perl
#
# $Id: at.cgi,v 1.2 2002/01/22 00:04:57 seb Exp $
# Main screen for editing attributes
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{at_save_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b}, $in{i} );

print_header( $text{at_title}, $file, $type, $suffix );

print "<table width=100% border>\n";
print "<tr $tb><td><b>$text{at_name}</b></td><td align=center><b>$text{at_oid}</b></td>";
print "<td  align=center><b>$text{at_description}</b></td>\n";
print "<td align=center><b>$text{at_syntax}</b></td>\n";
print "<td align=center><b>$text{at_match}</b></td>\n";
print "<td align=center><b>$text{at_type}</b></td>\n";
print "</tr>\n";

foreach $at ( sort keys %{$cbackend->{attributetype}} ){
    $nb = $#{$cbackend->{attributetype}{$at}};
    print "<tr $cb><td><a href=\"at_edit.cgi?b=$in{b}&i=$in{i}&at=$at\">$at</a></td>";
    print "<td>",$cbackend->{attributetype}{$at}[0], "</td>\n";
my $descrip = &extract_attribute('DESC', @{$cbackend->{attributetype}{$at}})||"$text{at_none}"; 
  print "<td> $descrip </td>\n";
my $syntax = &extract_attribute('SYNTAX', @{$cbackend->{attributetype}{$at}});
$syntax = " ".&extract_attribute('SUP', @{$cbackend->{attributetype}{$at}})unless $syntax; 
if ($syntax) { $complet = &table_syntax($syntax);
               $syntax="$syntax => $complet" if $complet;
             }

  print "<td> $syntax </td>\n";
my $case= &extract_attribute('EQUALITY', @{$cbackend->{attributetype}{$at}})||"$text{at_none}";
#my $libcase = &table_case($case)||'aucun';
  print "<td> $case </td>\n";
my $single= &table_single(@{$cbackend->{attributetype}{$at}});
  print "<td>$single </td></tr>\n";


}

print "</table>\n";
######## nouveau attribut #################
print "<hr><h3>$text{at_add_title}</h3>\n";
print "<form action=at_save.cgi method=post>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<table width=100% border>\n";
print "<tr $tb>";
print "<td><b>$text{at_name}:</b></td><td $cb><input size=40 name=at></td>";
print "</tr><tr $tb><td><b>$text{at_oid}:</td><td $cb></b><input size=40   name=oid></td>";
print "</tr><tr $tb><td><b>$text{at_description}:</b></td><td $cb><input size=40  name=description></td>";
print "</tr><tr $tb><td><b>$text{at_sup}:</td></b><td $cb><input size=40  name=sup></td>";

@listt = &list_syntax;
print "</tr><tr $tb><td><b>$text{at_syntax}&nbsp {$text{at_length}}:</b></td><td $cb>";
print list_input( 'syntax',\@listt,\@listt,
'1.3.6.1.4.1.1466.115.121.1.15-(String)'
		  );
print "{<input size=6 name=length>}</td>";
print "</tr></table>";
print "<table width=100% border>\n";
print "<tr $tb>";
print "<td><b>$text{at_single}:&nbsp</b><input type=checkbox name=single></td>";
print "<td><b>$text{at_collective}:&nbsp</b><input type=checkbox name=collective></td>";
print "<td><b>$text{at_obsolete}:&nbsp</b><input type=checkbox name=obsolete></td>";
print "</table>";
print "<table width=100% border>\n";
print "<tr $tb>";
print "<td><b>$text{at_no_user}:&nbsp</b><input type=checkbox name=no_user></td>";
print "<td><b>$text{at_usage}:&nbsp</b>";
print list_input( 'usage',[$text{'at_none'},'userApplication','directoryOperation','dSAOperation'],[$text{'at_none'},'userApplication','directoryOperation','dSAOperation'],$text{'at_none'});
print "</td>";
print "</table>";
print "<table width=100% border>\n";
print "<tr $tb>";

print "</tr><td $tb><b>$text{at_compare}:&nbsp</b></td><td $cb>$text{at_equa}&nbsp";
my @list_qu = &list_equa;
print &list_input ('equality',\@list_qu,\@list_qu,$text{'at_none'});
print "</td><td $cb>$text{at_substr}&nbsp&nbsp";
my @list_sub = &list_substr;
print &list_input ('substr',\@list_sub,\@list_sub,$text{'at_none'});
print "</td><td $cb>$text{at_order}&nbsp&nbsp";
my @list_order = &list_ordering;
print &list_input ('order',\@list_order,\@list_order,$text{'at_none'});


print "</td><td></td></tr></table>";
print "<input type=submit name=add_at value=$text{at_add}></form><hr>\n";

if( $in{i} ){
    footer( "include_edit.cgi?b=$in{b}&i=$in{i}", $text{at_back} );
}
else {
    footer( $in{b} ? "backend.cgi?b=$in{b}" : "index.cgi", $text{at_back} );
}
