#!/usr/bin/perl
#
# $Id: at_edit.cgi,v 1.2 2002/01/22 00:04:57 seb Exp $
# Screen for the edition of an attribute
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{at_edit_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b} );

print_header( $text{at_edit_title}, $file, $type, $suffix );
print "<form method=post action=at_save.cgi>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<table width=100% border>\n";
print "<tr $tb><td><b>$text{at}: $in{at}</b></td></tr><tr $cb><td></tr></table>";
my $at=$in{at};
my $descrip = &extract_attribute('DESC', @{$cbackend->{attributetype}{$at}})||"$text{at_none}"; 
my $top =  &extract_attribute('SUP', @{$cbackend->{attributetype}{$at}});
my $oid =  $cbackend->{attributetype}{$at}[0];
my $collective = present_att('COLLECTIVE',$cbackend->{attributetype}{$at});
my $obsol = present_att('OBSOLETE',$cbackend->{attributetype}{$at});
my $user = present_att('NO-USER-MODIFICATION',$cbackend->{attributetype}{$at});
my $usage =  &extract_attribute('USAGE', @{$cbackend->{attributetype}{$at}});
my $equal =  &extract_attribute('EQUALITY', @{$cbackend->{attributetype}{$at}});
my $sub =  &extract_attribute('SUBSTR', @{$cbackend->{attributetype}{$at}});
my $ord =  &extract_attribute('ORDERING', @{$cbackend->{attributetype}{$at}});

my $single =present_att('SINGLE-VALUE',$cbackend->{attributetype}{$at});
my $syntax = &extract_attribute('SYNTAX', @{$cbackend->{attributetype}{$at}});
$syntax = " ".&extract_attribute('SUP', @{$cbackend->{attributetype}{$at}})unless $syntax; 
$long="";
if ($syntax=~/\{/ ) { 
   ($debut,$fin) = $syntax=~ /(.+)\{(.+)\}/;
$syntax =$debut;
$long =$fin;
}

if ($syntax) { $complet = &retourne_syntax($syntax);  }
 
##########
print "<table width=100% border>\n";
print "<tr $tb>";
print "<td><b>$text{at_name}:</b></td><td $cb><input size=40 name=at value=$at ></td>";
print "</tr><tr $tb><td><b>$text{at_oid}:</td><td $cb></b><input size=40   name=oid  value=$oid></td>";
print "</tr><tr $tb><td><b>$text{at_description}:</b></td><td $cb><input size=60  name=description value=\"$descrip\"></td>";
print "</tr><tr $tb><td><b>$text{at_sup}:</td></b><td $cb><input size=40  name=sup value=$top ></td>";

@listt = &list_syntax;
print "</tr><tr $tb><td><b>$text{at_syntax}&nbsp {$text{at_length}}:</b></td><td $cb>";
print list_input( 'syntax',\@listt,\@listt,
$complet
		  ) unless $top;
print list_input( 'syntax',\@listt,\@listt,
$complet
		  ) if  $top;
print "{<input size=6 name=length value=$long>}</td>";
print "</tr></table>";
print "<table width=100% border>\n";
print "<tr $tb>";
print "<td><b>$text{at_single}:&nbsp</b><input type=checkbox name=single";
print " checked"  if  $single;
print "></td>";

print "<td><b>$text{at_collective}:&nbsp</b><input type=checkbox name=collective";
print " checked" if $collective;
print "></td>";
print "<td><b>$text{at_obsolete}:&nbsp</b><input type=checkbox name=obsolete";
print " checked" if $obsol;
print "></td>";
print "</table>";
print "<table width=100% border>\n";
print "<tr $tb>";
print "<td><b>$text{at_no_user}:&nbsp</b><input type=checkbox name=no_user";
print " checked" if $user;

print "></td>";
print "<td><b>$text{at_usage}:&nbsp</b>";
print list_input( 'usage',[$text{'at_none'},'userApplication','directoryOperation','dSAOperation'],[$text{'at_none'},'userApplication','directoryOperation','dSAOperation'],$usage);
print "</td>";
print "</table>";
print "<table width=100% border>\n";
print "<tr $tb>";

print "</tr><td $tb><b>$text{at_compare}:&nbsp</b></td><td $cb>$text{at_equa}&nbsp";
my @list_qu = &list_equa;
print &list_input ('equality',\@list_qu,\@list_qu,$equal);
print "</td><td $cb>$text{at_substr}&nbsp&nbsp";
my @list_sub = &list_substr;
print &list_input ('substr',\@list_sub,\@list_sub,$sub);
print "</td><td $cb>$text{at_order}&nbsp&nbsp";
my @list_order = &list_ordering;
print &list_input ('order',\@list_order,\@list_order,$ord);
############
print "</td></tr><tr><td><input type=submit name=del_at value=\"$text{at_edit_delete}\">";
print "&nbsp&nbsp<input type=submit name=mod_at value=\"$text{at_edit_save}\"></td><td></td><td></td></tr>\n";
print "</table></form>\n";



footer( "at.cgi?b=$in{b}&i=$in{i}", $text{at_edit_back} );
