#!/usr/bin/perl
#
# $Id: backend.cgi,v 1.1 2002/01/21 23:39:59 seb Exp $
# Main screen for the edition of a backend
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
require './parse_slapd_conf.pl';

my @backends = parse_slapd_conf( $config{slapd_conf_file} );
my $b        = $in{b};
my $cbackend = $backends[$b];

header( $text{index_title}, undef, undef, 1, undef, undef, $text{index_right} );
print "<center><b>Backend \"$cbackend->{suffix}\" ($cbackend->{type})</b></center>\n";

print "<hr><form action=backend_save.cgi method=post>\n";
print "<input type=hidden name=b value=$b><table border width=100%>\n";
print "<tr $tb><td><b>$text{backend_general}</b></td></tr>\n";
print "<tr $cb><td><table width=100%>\n";

print "<tr><td><b>", hlink($text{rootdn}, 'rootdn'), "</b></td>";
print "<td colspan=3><input size=50 name=rootdn value=\"$cbackend->{rootdn}\">";
print DN_chooser_button( 'rootdn', 0, $cbackend->{suffix} ), "</td></tr>\n";

print "<tr><td><b>", hlink($text{rootpw}, 'rootpw'), "</b></td>";
print "<td colspan=3><input size=50 name=rootpw value=\"$cbackend->{rootpw}\"></td></tr>\n";

print "<tr><td><b>", hlink($text{readonly}, 'readonly'), "</b></td>";
print "<td>", yesno_input('readonly', $cbackend->{readonly}), "</td>\n";

print "<td><b>", hlink($text{defaultaccess}, 'defaultaccess'), "</b></td><td>\n";
print list_input( 'defaultaccess',
		  [ $text{default}, $text{access_none}, $text{access_compare}, $text{access_search}, $text{access_read}, $text{access_write}, $text{access_delete} ],
		  [ '""', 'none', 'compare', 'search', 'read', 'write', 'delete' ],
		  $cbackend->{'defaultaccess'} || '""' ), "</td></tr>\n";

print "<tr><td><b>", hlink($text{schemacheck}, 'schemacheck'), "</b></td>";
print "<td>", yesno_input( 'schemacheck', $cbackend->{schemacheck} ), "</td>\n";

print "<td><b>", hlink($text{lastmod}, 'lastmod'), "</b></td>";
print "<td>", yesno_input('lastmod', $cbackend->{lastmod}), "</td></tr>\n";

print "<tr><td><b>", hlink($text{sizelimit}, 'sizelimit'), "</b></td><td>";
print "<input size=5 name=sizelimit value=\"$cbackend->{sizelimit}\"></td>\n";

print "<td><b>", hlink($text{timelimit}, 'timelimit'), "</b></td><td>";
print "<input size=5 name=timelimit value=\"$cbackend->{timelimit}\"></td></tr>\n";

print "</table></td></tr></table><br>\n";

if( $cbackend->{type} eq 'ldbm' ) {
    print "<table border width=100%>\n";
    print "<tr $tb><td><b>$text{backend_ldbm}</b></td></tr>\n";
    print "<tr $cb><td><table width=100%>\n";

    print "<tr><td><b>", hlink($text{directory}, 'directory'), "</b></td>";
    print "<td colspan=3><input size=40 name=directory value=\"$cbackend->{directory}\">";
    print file_chooser_button( 'directory', 1 );
    print "</td></tr>\n";

    print "<tr><td><b>", hlink($text{cachesize}, 'cachesize'), "</b></td>";
    print "<td><input size=5 name=cachesize value=\"$cbackend->{cachesize}\"></td>\n";

    print "<td><b>", hlink($text{dbcachesize}, 'dbcachesize'), "</b></td>";
    print "<td><input size=5 name=dbcachesize value=\"$cbackend->{dbcachesize}\"></td></tr>\n";

    print "<tr><td><b>", hlink($text{dbcachenowsync}, 'dbcachenowsync'), "</b></td>";
    print "<td>", yesno_input('dbcachenowsync', $cbackend->{dbcachenowsync}), "</td>\n";

    print "<td><b>", hlink($text{mode}, 'mode'), "</b></td>";
    print "<td><input size=5 name=mode value=\"$cbackend->{mode}\"></td></tr>\n";

    print "</table></td></tr></table><br>\n";
}

if( $cbackend->{type} eq 'shell' ) {
    print "<table border width=100%>\n";
    print "<tr $tb><td><b>$text{backend_shell}</b></td></tr>\n";
    print "<tr $cb><td><table width=100%>\n";

    foreach my $script ( qw(bind unbind search compare modify modrdn add delete abandon) ){
	print "<tr><td><b>", hlink($text{$script}, 'shellscripts'), "</b></td>";
	print "<td>", file_input($script, $cbackend->{$script}), "</td></tr>\n";
    }

    print "</table></td></tr></table><br>\n";
}

if( $cbackend->{type} eq 'passwd' ) {
    print "<table border width=100%>\n";
    print "<tr $tb><td><b>$text{backend_passwd}</b></td></tr>\n";
    print "<tr $cb><td><table width=100%>\n";
    print "<tr><td><b>", hlink($text{file}, 'file'), "</b></td>";
    print "<td>", file_input('file', $cbackend->{file}), "</td></tr>\n";
    print "</table></td></tr></table><br>\n";
}

print "<table width=100%><tr>\n";
print "<td align=left><input type=submit name=save value=\"$text{button_save}\"></td>\n";
print "<td align=center><input type=submit name=edit value=\"$text{button_edit_schema}\"></td>\n";
print "<td align=right><input type=submit name=delete value=\"$text{button_delete}\"></td>\n";
print "</tr></table></form>\n";

print "<hr><h3>$text{backend_others}</h3>\n";

if( $cbackend->{type} ne 'ldbm' ) {
    icons_table
	( [ "access.cgi?b=$b",   "oc.cgi?b=$b",      "at.cgi?b=$b"   ]
	, [ $text{access},       $text{objectclass}, $text{attribut} ]
        , [ 'images/access.gif', 'images/oc.gif',    'images/at.gif' ]
        );
}
else {
    icons_table
	( [ "access.cgi?b=$b",   "oc.cgi?b=$b",      "at.cgi?b=$b",   "ldbm_index.cgi?b=$b" ]
        , [ $text{access},       $text{objectclass}, $text{attribut}, $text{index}          ]
        , [ 'images/access.gif', 'images/oc.gif',    'images/at.gif', 'images/index.gif'    ]
        );
}

print "<hr>\n";

footer( 'index.cgi', $text{backend_back} );
