#!/usr/bin/perl
#
# $Id: include.cgi,v 1.1 2002/01/21 23:39:59 seb Exp $
# Main screen for editing included files
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{oc_save_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b}, $in{i} );

print_header( $text{include_title}, $file, $type, $suffix );

$i = 0;
icons_table( [ map( { $i++; "include_edit.cgi?b=$in{b}&i=$i" } @{$cbackend->{include}} ) ],
	     [ @{$cbackend->{include}} ],
	     [ map( "images/include.gif", @{$cbackend->{include}} ) ]
	    );

print "<hr>\n";

print "<form method=post action=include_save.cgi>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<h2>$text{include_add_title}</h2>\n";
print "<input name=include size=50>", file_chooser_button( 'include' ), "&nbsp;&nbsp;\n";
print "<input type=submit name=add_include value=$text{include_add}></form><hr>\n";

footer( $in{b} ? "backend.cgi?b=$in{b}" : "index.cgi", $text{include_back} );
