#!/usr/bin/perl
#
# $Id: index.cgi,v 1.1 2002/01/21 23:39:59 seb Exp $
# Main screen
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#                      and E. German <germanlinux@yahoo.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
require './manage_daemon.cgi';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
if( not defined $file ){
    print_header( '', $config{slapd_conf_file}, $GLOBAL_TYPE, '' );
    print $text{index_no_conf};
    print "<hr>\n";
    footer( '/', $text{index_back} );
    exit;
}
my $cbackend = $backends->[$in{b}];

print_header( '', $file, $type, $suffix );

my %acls = get_module_acl();

# <Temp>
#  print << "EOF";
#  <p align=center><b>This is still alpha software ! Use at your own risk. You've been warned.</b></p>
#  <p align=center>Bug reports, advices, patches or even compliments are all welcomed.</p>
#  <hr>
#  EOF
# </Temp>

print "<table width=100% border>\n";
print "<tr $tb><td><b>$text{index_backends}</b></td><td><b>$text{index_type}</b></td></tr>\n";

for my $i (0..$#{@$backends}) {
    next if $backends->[$i]{type} =~ /_.+_/;
    print "<tr $cb><td><i><a href=backend.cgi?b=$i>";
    print "$backends->[$i]{suffix}</a></i></td><td>$backends->[$i]{type}";
    print "</td></tr>\n";
}

print "</table>\n";
print "<a href=backend_add.cgi>$text{index_add_backend}</a><p>\n" if $acls{manage};

print "<hr><form action=backend_save.cgi method=post>\n";
print "<input type=hidden name=b value=0>";
print "<table border width=100%>\n";
print "<tr $tb><td><b>$text{index_global}</b></td></tr>\n";
print "<tr $cb><td><table width=100%>\n";

print "<tr><td><b>", hlink($text{pidfile}, 'pidfile'), "</b></td>";
print "<td colspan=3><input size=40 name=pidfile value=\"$cbackend->{pidfile}\">";
print file_chooser_button( 'pidfile' );
print "</td></tr>\n";

print "<tr><td><b>", hlink($text{argsfile}, 'argsfile'), "</b></td>";
print "<td colspan=3><input size=40 name=argsfile value=\"$cbackend->{argsfile}\">";
print file_chooser_button( 'argsfile' );
print "</td></tr>\n";

print "<tr><td><b>", hlink($text{srvtab}, 'srvtab'), "</b></td>";
print "<td colspan=3><input size=40 name=srvtab value=\"$cbackend->{srvtab}\">";
print file_chooser_button( 'srvtab' );
print "</td></tr>\n";

print "<tr><td><b>", hlink($text{'loglevel'}, 'loglevel'), "</b></td>";
print "<td><input name=loglevel value=\"$cbackend->{loglevel}\" size=5>";
print "</td>\n";

print "<td><b>", hlink($text{referral}, 'referral'), "</b></td>";
print "<td><input name=referral value=\"$cbackend->{referral}\" size=30>";
print "</td></tr>\n";

print "<tr><td><b>", hlink($text{schemacheck}, 'schemacheck'), "</b></td>";
print "<td>", yesno_input( 'schemacheck', $cbackend->{schemacheck} ), "</td>\n";

print "<td><b>", hlink($text{defaultaccess}, 'defaultaccess'), "</b></td><td>\n";
print list_input( 'defaultaccess',
		  [ $text{default}, $text{access_none}, $text{access_compare}, $text{access_search}, $text{access_read}, $text{access_write}, $text{access_delete} ],
		  [ '""', 'none', 'compare', 'search', 'read', 'write', 'delete' ],
		  $cbackend->{defaultaccess} || '""' ), "</td></tr>\n";

print "<tr><td><b>", hlink($text{sizelimit}, 'sizelimit'), "</b></td>";
print "<td><input size=5 name=sizelimit value=\"$cbackend->{sizelimit}\"></td>\n";

print "<td><b>", hlink($text{timelimit}, 'timelimit'), "</b></td>";
print "<td><input size=5 name=timelimit value=\"$cbackend->{timelimit}\"></td></tr>\n";

print "</table></td></tr></table><br>\n";
print "<input type=submit name=save value=\"$text{button_save}\"></form>\n";

print "<hr><h3>$text{index_others}</h3>\n";

icons_table( [ "access.cgi?b=0",    "include.cgi?b=0",    "oc.cgi?b=0",       "at.cgi?b=0"    ]
	   , [ $text{access},       $text{include},       $text{objectclass}, $text{attribut} ]
	   , [ 'images/access.gif', 'images/include.gif', 'images/oc.gif',    'images/at.gif' ]
           );

print "<hr><h3>$text{daemon_status}</h3>\n";
if( $acls{stop} ){
  my $job =$cbackend->{pidfile}; 
  print  &restart_button($job);
}

print "<hr>\n";
footer( '/', $text{index_back} );

