#!/usr/bin/perl -w

use strict;

my $one = shift;
my $two = shift;

open OLDONE, $one or die "open: $one: $!";
open OLDTWO, $two or die "open: $two: $!";
open NEWTWO, ">$two.tmp" or die "open: $two.tmp: $!";

my( @oldone, @oldtwo );

while( <OLDONE> ){
    chomp;
    push @oldone, [ split( /=/, $_, 2) ];
}

while( <OLDTWO> ){
    chomp;
    next if /^\s*$/;
    push @oldtwo, [ split( /=/, $_, 2) ];
}

foreach( @oldone ){
    if( not defined $_->[0] ){
	print NEWTWO "\n";
	next;
    }

    if( not defined $_->[1] ){
	print NEWTWO "$_->[0]\n";
	next;
    }

    my $name  = $_->[0];
    my $value = '';

    for my $i (0..$#oldtwo){
	if( $oldtwo[$i][0] eq $name ){
	    $value = $oldtwo[$i][1];
	    splice @oldtwo, $i, 1;
	    last;
	}
    }

    print NEWTWO "$name=$value\n";
}

close NEWTWO;
close OLDTWO;
close OLDONE;
