#!/usr/bin/perl
#
# $Id: stop.cgi,v 1.1 2002/01/21 23:39:59 seb Exp $
# Stop the running slapd process
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by E. German <germanlinux@yahoo.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
require './parse_slapd_conf.pl';
use POSIX;
my @backends = parse_slapd_conf( $config{slapd_conf_file} );
my $cbackend = $backends[0];
my $npid=0;
my $pid = $cbackend->{pidfile};

if ($pid) { if (open(PID, $pid)) {
	<PID> =~ /(\d+)/;
	$npid = $1;
	close(PID);
	}
}

if ($config{'stop_command'}) {
	# Use a stop script
	$out = system("$config{'stop_command'} >/dev/null");
	if ($out) {
		&error("<pre>$text{error_stop}</pre>");
		}
	}
else {
	# Try the ordinary kill 
	if ($npid) {
		my $i=0 ;
		for($i=0; $i<40; $i++) {
			if (!kill(15, $npid)) { last; }
			sleep(1);
		}
	}  
	else {
		# stop  the slapd  kill directly
		$out = system("killall slapd");
		if ($out) { 
			&error("<pre>$text{error_stop}</pre>");
		}
	}
}
&redirect('./index.cgi');

