#!/usr/bin/perl

## ShopAdmin 
## (c) 1998,1999 Sascha Klauder ( sascha@ibd-web.de )

do "../web-lib.pl";
require "saa-lib.pl";

$VER = "0.12";

## read config and perform various checks ##
&init_config($module_name);
$DBA_PATH = $config{DB_ADM_PATH};

if( !$DBA_PATH ) {
 &error("The ShopAdmin Configurator has not yet been configured.<br>
         Please use <a href=\"/config.cgi?$module_name\">Module Config</a> to configure this
	 module.")
}

if( !-e $DBA_PATH ) {
 &error("The configured ShopAdmin installation directory 
        <font color=blue>$DBA_PATH</font> does not exist.")
}

## get version information ##
open( VER,"<$DBA_PATH/version" ) || &fail_warn("Unable to get version information, perhaps Module Config incomplete or outdated ShopAdmin version");
while( <VER> ) { push( @VER_DATA,$_ ) }
close( VER );
$DBA_VER = $VER_DATA[0];
$PATCHLVL= $VER_DATA[1];
$LANG    = $VER_DATA[2];

if( !$DBA_VER ) {
 &fail_warn("Unable to get version information.")
}

if( $DBA_VER < 0.51 ) { 
 &error("Sorry, but ShopAdmin versions < 0.54 are not supported.<br>
         Please upgrade your ShopAdmin.")
}

## go ahead ##
&header("ShopAdmin/Configuration - Version $VER","images/header.gif",undef,1,1);
print "<hr>";

## get config'd users ##
$CONF_PATH = $DBA_PATH . "/lib/users/";
opendir( CFDIR,$CONF_PATH ) || &io_warn("Oops: $0 was unable to read confdir $CONF_PATH : $!");
@confs = readdir( CFDIR );
closedir( CFDIR );
shift( @confs ); shift( @confs );

for( $i=0; $i<=$#confs; $i++ ) {
 my $stop = rindex( $confs[$i],"." );
 $USERS[$i] = substr( $confs[$i],0,$stop );
}
$NO_FILES = $i;

if( $DBA_PATH =~ /-de/ ) { $module = "DBAdmin-de" } else { $module = "DBAdmin" }
&read_acl(\%acl, \%users);
foreach $u (keys %users) {
 push(@canaccess, $u) if ($acl{$u,$module});
}
sort( @canaccess );
$NO_USERS = $#canaccess + 1;

print "<table border width=100%>\n";
print "<tr $tb><th>Info</th></tr>\n";
print "<tr $cb><td><table width=100%>
	   <tr>
		<td align=left><ul><li>ShopAdmin installation directory:</li></td> 
		<td align=left><font color=blue><b>$DBA_PATH</b></font></td>
	   </tr>
	   <tr $cb>
	    <td align=left><ul><li>ShopAdmin version:</li></td>
		<td align=left><font color=blue><b>$DBA_VER</b></font> patchlevel <font color=blue><b>$PATCHLVL</b></font> language <font color=blue><b>$LANG</b></font></td>		
	   </tr>
	   <tr>
		<td align=left><ul><li>Files found in config directory:</li></td>
		<td align=left><font color=blue><b>$NO_FILES</b></font></td>
	   </tr>
	   <tr>
		<td align=left><ul><li>Webmin accounts configured for ShopAdmin:</li></td>
		<td align=left><font color=blue><b>$NO_USERS</b></font></td>
	   </tr></table>
 	   </td></tr></table></center><br>";
	   
print "<table border width=100%>\n";
print "<tr $tb><td><b>Webmin accounts configured for ShopAdmin (<font color=blue><b>$module</b></font>)</b></td>\n";
print "<tr $cb><td><table width=100%>\n";
$i = 0;
foreach( @canaccess ) {
 if( $i % 4 == 0 ) { print "<tr>\n" }
 if( !-e $CONF_PATH . $_ . ".conf" ) {
  print "<td><i><a href=\"edit_user.cgi?user=$_\">$_</a></i></td>"
 } else {
  print "<td><b><a href=\"edit_user.cgi?user=$_\">$_</a></b></td>"
 }
 if( $i++ % 4 == 3 ) { print "</tr>\n" }
}
print "</table></td></tr></table>\n";
print "<br><hr>\n";

&footer("/","index");
