/*
 *    author: Lloyd Dupont
 *    mail: lloyd@galador.net
 *    Copyright (C) 2000 Lloyd Dupont
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 * an action to select a menu. which means repaint it with selected color,
 * show submenu...<BR>
 * I use an action so any select actio is delayed, so user can move its mouse
 * nervously and step in and out from its current select without changing it.
 * It is also very usefull when moving mouse across different MenuWindow.
 * i let it times to go to next window before hiding it.
 */
public class ActionSelectMenu implements Action
{
    MenuPanel target;
    int line;

	/** the menu line to select on given panel. */
    public ActionSelectMenu(MenuPanel mp, int s) {
        if(mp == null)
            throw new NullPointerException();
        target = mp;
        line = s;
    }
	/** @param key doesn't matter. */
    public void action(String key) {
        target.setSelected(line);
    }

	public boolean equals(Object obj)
	{
		if(obj == this)
			return true;
		if(obj == null)
			return false;
		if(obj instanceof ActionSelectMenu) {
			ActionSelectMenu asm = (ActionSelectMenu) obj;
			return line == asm.line && target.equals(asm.target);
		}
		return false;
	}
}