/*
 *    author: Lloyd Dupont
 *    mail: lloyd@galador.net
 *    Copyright (C) 2000 Lloyd Dupont
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
import java.applet.*;
import java.lang.reflect.*;
import java.io.Serializable;

/**
 * an acrtio object to call javascript code from Java. Of course
 * you must have tagged your applet with <B>MAYSCRIPT</B> and have
 * the proper jar in your classpath (recent version of IE and netscape
 * do have), but, anyway, this won't cause LinkError as it use reflection
 * to call any method.
 *
 * @see action
 */
public class JScriptAction implements Action, Serializable
{
	String command;
	Applet applet;

	/**
	 * the constructor.
	 * @param applet You should pass a not null arg applet, which would be
	 * used to find any necessary info for invocation.
	 * @param cmd it is an optional parameter to be called if arg of
	 * <B>action()</B> is null
	 */
	public JScriptAction(Applet a, String cmd)
	{
		applet = a;
		command = cmd;
		if(a == null)
			throw new NullPointerException("Applet is null");
	}

	/**
	 * in voke the javascript commands provided, if it could.
	 * @param jscmd if it is null use the command in the constructor.
	 */
	public void action(String jscmd)
	{
		if(jscmd == null)
			jscmd = command;
		if(jscmd == null)
			return;

		try {
			Object navigator = null;
			Class c = Class.forName("netscape.javascript.JSObject");
			Method ms[] = c.getMethods();
			for (int i = 0; i < ms.length; i++)
		        if (ms[i].getName().equals("getWindow"))
					try {
						navigator = ms[i].invoke(null, new Object[]{applet});
						if(navigator != null)
							break;
					}
					catch(Throwable t) {
						System.err.println(t);
						t.printStackTrace();
						if(t instanceof InvocationTargetException) {
							t = ((InvocationTargetException)t).getTargetException();
							System.err.println(t);
							t.printStackTrace();
						}
					}

		    if(navigator != null) {
				ms = navigator.getClass().getMethods();
				for(int i=0; i< ms.length; i++)
					if(ms[i].getName().equals("eval")) {
						Class[] args = ms[i].getParameterTypes();
						if(args.length == 1 && args[0].equals(String.class)) {
							ms[i].invoke(navigator, new Object[]{jscmd});
							return;
						}
					}
			}
		}
		catch (Exception e) {
			System.err.println("while executing: " + jscmd);
			System.err.println(e);
		    e.printStackTrace();
		}
	}
}