/*
 *    author: Lloyd Dupont
 *    mail: lloyd@galador.net
 *    Copyright (C) 2000 Lloyd Dupont
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

/**
 * a class to test development with menu API. you could run it with: <BR>
 * <TT>java TestFrame [<my menu plist>]</TT><BR>
 * my menu plist could be null, in this case it will look for
 * "<I>menu.plist</I>".
 */
public class TestFrame extends Frame
{
    void configure(String file) throws Exception {
        FileReader fr = new FileReader(file);

        Object items = PList.read(fr);
        Object prefs = PList.read(fr);

        setLayout(new BorderLayout());
        MenuPanel menu = new MenuPanel(items);
        add(menu, BorderLayout.CENTER);
        menu.getController().init((Hashtable) prefs);
    }
    public TestFrame() {
        super("Lloyd's menu");
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    }
    public void processWindowEvent(WindowEvent we) {
        if(we.getID() == WindowEvent.WINDOW_CLOSING)
            System.exit(0);
        super.processWindowEvent(we);
    }
    public static void main(String[] arg) throws Exception {
        TestFrame tf = new TestFrame();
		String s = arg.length > 0 ? arg[0] : "menu.plist";
        tf.configure(s);
        tf.pack();
        tf.setLocation(100, 100);
        tf.show();
    }
}