#!/usr/bin/perl

# Theme "gehrigal"
# Autor: Alexander Gehrig
# Email: webmin@gehrigal.de
# Internet: http://www.gehrigal.net

# Reguired libraries
require './web-lib.pl';
use FindBin;
use File::Spec;



my @path = grep /\S+/, File::Spec->splitdir($FindBin::Bin);

require "./$path[-1]/theme-lib.pl";


&init_theme(); # theme-lib.pl 
&list_menu();  # theme-lib.pl
&init_config(); # web-lib.pl

# Set local variables
local $hostname = &get_system_hostname();
local $product = &getproductname();
local $ver = &get_webmin_version();
local $smart_user = $ENV{'REMOTE_USER'};
local $smart_ip = $ENV{'REMOTE_ADDR'};
local $smart_time = localtime();
local $smart_uptime =  &smart_uptime();


if ($gconfig{'real_os_type'}) {
	$ostr = "$gconfig{'real_os_type'} $gconfig{'real_os_version'}";
	}
else {
	$ostr = "$gconfig{'os_type'} $gconfig{'os_version'}";
	}


#**SUB********************************
#
# name: smart_title
# info: Output the Text- or Imagetile for SmartStart
#

sub smart_title
{
    my $skindir = &rw_skin();
    my $smart_img = "$skindir".'smartstart.gif';
    $return_1 = "";
    $return_2 = "Smart Start: $hostname";
    if( -e "$smart_img"){$return_1 = $smart_img;}
    
}

#**END_SUB's**************************

#*********************************************
# Output HTML
&smart_title();

&header("$return_2","$return_1",undef,0,1,0);

print <<EOF;
<hr>
<blockquote>
<TABLE border="0" width="80%" cellspacing="0" cellpadding="0" $cb>
EOF
     

foreach $c (@cats) {
print "<tr $tb align=\"center\"><td colspan=\"3\"><b>$cats{$c}</b> </td></tr>\n";


$pos = 0;
$cols = $gconfig{'nocols'} ? $gconfig{'nocols'} : 3;
$per = 100.0 / $cols;
foreach $m (@modules) {
			next if ($m->{'category'} ne $c);
					
			if ($pos % $cols == 0) { print "<tr $cb>\n"; }
			print "<TD ><A TARGET=Hauptframe HREF=/$m->{'dir'}/ ><img src=$m->{'dir'}/images/icon.gif alt=\"$m->{'desc'}\" border=0 width=\"24\" height=\"24\">  $m->{'desc'}</A></TD>\n";
			if ($pos++ % $cols == $cols - 1) { print "</tr>\n"; }
			}
		}
		
if ($product eq "webmin")
{		
print <<EOF;
</table>
<br>
<Table border="0">
<tr>
<td $tb colspan="2"><b>Systeminformation</b></td>
<td $tb colspan="2"><b>Userinfo</b></td>
</tr>
<tr>
<td $cb><b>OS:</b></td>
<td $cb>$ostr</td>
<td $cb><b>User:</b></td>
<td $cb>$smart_user</td>
</tr>
<tr>
<td $cb><b>Webminversion:</b></td>
<td $cb>$ver</td>
<td $cb><b>Remote IP:</b></td>
<td $cb>$smart_ip</td>
</tr>
<tr>
<td $cb><b>Hostname:</b></td>
<td $cb>$hostname</td>
</tr>
<tr>
<td $cb><b>Time:</b></td>
<td $cb>$smart_time</td>
</tr>
<tr>
<td $cb><b>UpTime:</b></td>
<td $cb>$smart_uptime</td>
</table>

</blockquote>
<hr>
</BODY>
</HTML>
EOF
}
else
{
print <<EOF;
</table>
<br>
<Table border="0">
<tr>
<td $tb colspan="2"><b>Systeminformation</b></td>
<td $tb colspan="2"><b>Userinfo</b></td>
</tr>
<tr>
<td $cb><b>Time:</b></td>
<td $cb>$smart_time</td>
<td $cb><b>User:</b></td>
<td $cb>$smart_user</td>
</tr>
<tr>
<td></td><td></td>
<td $cb><b>Remote IP:</b></td>
<td $cb>$smart_ip</td>
</tr>
</table>

</blockquote>
<hr>
</BODY>
</HTML>
EOF
	
}	
