# theme-lib.pl
# De-Discription: Diese Libary ist Teil des Gehrigal-Themes fuer Webmin
# En-Discription: This libary is a part of the Gehrigal-Theme for Webmin
# Autor: Alexander Gehrig
# Mail: webmin@gehrigal.net
# WWW: Http://www.gehrigal.info

# De:
# Diese Libary ist GPL! 
# Es wird jedoch gebeten einen Hinweis auf den urspruenglichen Autor zu setzten - DANKE!

# En:
# This Software is GPL!
# Please set some information about the autor in your software. - THANK YOU!

# Changelog 
#		Small fix for @path ( add grep /\+S/ )
# 		init_theme(): Add default value for $nam
#		Delete init_theme3_o() - needed by an very old version
#		Delete init_theme3() - needed by an very old version
#		Delete init_theme_o() - needed by an very old version
#		Delete list_menu_old() - needed by an very old version

use Socket;
use FindBin;
use File::Spec;


my @path = grep /\S+/, File::Spec->splitdir($FindBin::Bin);

#**VARIABLEN_DEKLERATION*******************************
#
# In den folgenden Zeilen werden einige globale Variablen definiert
#
$wweblib = './web-lib.pl'; # Webmin web-lib.pl Libary
$std_path = "./$path[-1]/"; # Standardpfad fuer die Config-Files
$skin_dir = 'skins/'; # Pfad in dem die Verzeichnisse der einzelnen Skins liegen
$wtconfig = 'config'; # Webmin Themeconfig-File
$wtcss = 'config.css'; # Webmin Themeconfig-File fuer CSS ( Main Frame )
$themec = 'theme.config'; # Theme Config-File 
$themecss = 'theme.css'; # Theme Config-File fuer CSS ( Navigation )

#**SUB**************************************************
#
# name: filetohash
# info: Reads a file and split each line in two parts ( name and value ) - since v0.32
# input: filename
# output: hash

sub filetohash
{
	my $file = $_[0];
	my %hash = ();
	my @temp = ();
	my $line = "";
	my $name = "";
	my $value = "";
	
		
	open(FILE, "< $file") or die "Error while accessing $file";
	@temp = <FILE>;
	close(FILE);

	chomp @temp;
	
	open( TESTFILE, "> test2");
	foreach $line (@temp)
	{
    	($name, $value) = split "=", $line, 2;
    	$hash{$name} = $value;
    	print TESTFILE "$name $value \n";
	}
	close();
	return %hash;
	
}


#**SUB**************************************************
#
# name: rw_skin
# info: Gibt neuen Pfad an fuer *.css und  *.config, sowie config. Jedoch nur wenn rw_skin gesetzt ist!

sub rw_skin
{ 
my $themefile = "$std_path"."$themec";
my %hash = &filetohash("$themefile");

my $skin_path = $hash{rw_skin};

return "$skin_path";
}







#**SUB**************************************************
# 
# name: webmin()
# info: Diese Funktion uebernimmt einige Prozeduren von web-lib.pl

sub webmin
{
do $wweblib;
&init_config();
}


#**SUB**************************************************
#
# name: init_theme()
# info: Read theme configuration (file: theme.config)
# 

sub init_theme
{
#use Sys::Hostname;

my $skin_path = &rw_skin();
my $themefile = "$skin_path"."$themec";

my %hash = &filetohash("$themefile");
 
# $TG[name]   = $hash([entry])  
# TG = Theme Gehrigal 
#
   
$nbc = $hash{nav_backcolor}; # Hintergrund fuer Nav-Frame
$TGbackground = $hash{nav_backcolor}; # Background Color for Navigation
$nfc = $hash{nav_fontcolor}; # Schriftfarbe fuer Nav-Frame
$TGfontcolor = $hash{nav_fontcolor}; # Fontcolor of navigation
$nlc = $hash{nav_linkcolor}; # Linkfarbe fuer Nav-Frame
$TGlinkcolor = $hash{nav_linkcolor}; # linkcolor of navigation
$nalc = $hash{nav_alinkcolor}; # Linkfarbe ( aktiv ) fuer Nav-Frame
$TGalinkcolor = $hash{nav_alinkcolor}; # color of active link
$nvlc = $hash{nav_vlinkcolor}; # Linkfarbe ( old ) fuer Nav-Frame
$TGvlinkcolor = $hash{nav_vlinkcolor}; # color of old links
$nff = $hash{nav_fontface}; # Schriftart fuer Nav-Frame
$TGfontface = $hash{nav_fontface}; # main fontface
$ncm = "$skin_dir"."$hash{nav_cssmode}"; # Verweis auf css-File (Nav-Frame)
$TGcssmode = "$skin_dir"."$hash{nav_cssmode}"; # navigation cssmode ( link to css file)
$nl = "$skin_dir"."$hash{nav_logo}"; # Verweis auf Logo (Nav-Frame)
$TGnav_wlogo = "$skin_dir"."$hash{nav_logo}"; # webmin navigation logo
$TGnav_ulogo = "$skin_dir"."$hash{nav_ulogo}"; # usermin navigation logo
$nbg = "$skin_dir"."$hash{nav_bkgrd}"; # Verweis auf Hindergrundbild ( Nav-Frame )
$np = $hash{nav_position}; # Frameposition von Nav-Frame ( left / right )
$namc = $hash{nav_ammenuc}; # Mainmenue *aktiv* Hindergrundfarbe ( Nav-Frame )
$namf = $hash{nav_ammenuf}; # Mainmenue *aktiv* Schriftfarbe ( Nav-Frame )
$nambg = "$skin_dir"."$hash{nav_ammenu_bgimage}"; # Mainmenue *aktiv* Hintergundbild ( Nav-Frame )
$nam_tmpl = $hash{nav_ammenu_tmpl}; # Mainmenue *aktiv* Template ( Nav-Frame )
$nmmc = $hash{nav_mmenuc}; # Mainmenue Hindergrundfarbe ( Nav-Frame )
$nmmf = $hash{nav_mmenuf}; # Mainmenue Schriftfarbe ( Nav-Frame )
$nmmbg = "$skin_dir"."$hash{nav_mmenu_bgimage}"; # Mainmenue Hintergrundbild ( Nav-Frame )
$nmm_tmpl= $hash{nav_mmenu_tmpl}; # Mainmenue Template ( Nav-Frame )
$nsc = $hash{nav_subcolor}; # Submenue Hindergrundfarbe ( Nav-Frame )
$nsfc = $hash{nav_subfcolor}; # Submenue Schriftfarbe (Nav-Frame )
$nsbg = "$skin_dir"."$hash{nav_sub_bgimage}"; # Submenue Hintergrundbild ( Nav-Frame )
$ns_tmpl = $hash{nav_sub_tmpl}; # Submenue Template ( Nav-Frame )
$nadm = $hash{nav_adm}; # Bezeichner fuer Admin-Feld ( Nav-Frame )
$nan = $hash{nav_admname}; # Name des Administrators ( Nav-Frame ) 
$ntinfo = $hash{nav_themeinfo}; # Bezeichner fuer Themeinfo-Feld ( Nav-Frame )
$nam = $hash{nav_admmail}; # email des Administrators ( Nav-Frame )
$nhtp = $hash{nav_http}; # URL fuer Logo-Link ( Nav-Frame )
$nlogoutbg = "$skin_dir"."$hash{nav_logout_bgimage}"; # Hintergrundbild fuer den Logout-Link ( Nav-Frame ) 
$mh1 = $hash{main_h1color}; # H1-Frabe ( Main-Frame )
$mbgcolor = $hash{main_backc}; # Hindergrundfarbe fuer Main-Frame
$mtext = $hash{main_fcolor}; # Schriftfarbe fuer Main-Frame
$mlink = $hash{main_linkc}; # Linkfarbe fuer Main-Frame
$mbgimage = $hash{main_bgimage}; # Hindergundbild fuer Main-Frame
$mhr = $hash{main_hrcolor}; # HR-Farbe fuer Main-Frame
$mtbh = $hash{main_tbheaderc}; # Tableheader-Farbe ( Main-Frame)
$mtbhf = $hash{main_tbfcolor}; # Table-Schriftfarbe ( Main-Frame )
$mcb = $hash{main_tbcolor}; # Table-Frame ( Main-Frame )
$nhr = $hash{nav_hrcolor}; # HR-Farbe im Nav-Frame
$mst_1 = $hash{main_start};# Startseite Mainmenue
$mstn_1 = $hash{main_startn}; # Sartseite Mainmenue ( Name )
$rw_navcgi = $hash{rw_nav_cgi}; # Standard nav.cgi ueberschreiben (Notloesung)
$cols_nav = $hash{cols_nav_frame}; # Angabe der Breite des NAV-Frames
$jmenu = $hash{jmenu}; # Angabe ob das Java-Menue verwendet werden soll (Nav-Frame)
# Skininfo
$skin_info = "$skin_dir"."$hash{skin_info}";

if($hash{skin_info} ne ''){$skin_info = "<p><b><a target='_top'  href='$skin_info'><font size='3'>[Skininfo]</font></a></b></p>\n";}else{$skin_info="";}

if($cols_nav eq ''){$cols_nav = 235; $nav_tbl_width= $cols_nav - 20;} 

if($rw_navcgi ne '1'){$rw_navcgi = 'nav.cgi';}else{$rw_navcgi = 'skin_nav.cgi'};

if($mstn_1 ne ''){$mst = "<TR><TD WIDTH=\"100%\"><a target=\"Hauptframe\" href=\"$mst_1\"><font color=\"$nfc\">$mstn_1</font></a></TD></TR>\n";}

# Navigation Logo
if ($TGnav_ulogo eq '') {$TGnav_ulogo = $TGnav_wlogo;}
if ($TGnav_wlogo eq '') {$TGnav_wlogo = $TGnav_ulogo;}

# Mail
#if ($nam == "default") { $nam = "root".'@'.&hostname(); }
($nam_1, $nam_2) = split '@', $nam;


if($nl ne '')
{
$nl_1 = 'checked';
}
else
{
$nl_1 = ' ';
}

if($nbg ne '')
{
$nbg_1 = 'checked';
}
else
{
$nbg_1 = ' ';
}

if($ncm ne '')
{
$ncm1='checked';
}
else
{
$ncm1='';
}

# Template fuer Mainmenue (NAV-Frame)
if($nmm_tmpl eq "")

{
    # Standardtemplate
    $nmm_tmpl1="<TR><TD style=\"background-image:url($nmmbg)\" bgcolor=\"$nmmc\"><A TARGET=Inhalt HREF='";
    $nmm_tmpl2="'><b><FONT color=\"$nmmf\">";
    $nmm_tmpl3="</FONT></b></A></TD><TD WIDTH=\"5\"></TD></TR>";
}
else
{
    # Skinspezifisches Template
    #open(TEST, "> test");
    #print TEST "$nmm_tmpl";
    #close(TEST);
    # $nmm_tmpl="<TR><TD colspan='2' valign='middle' align='center' background='/skins/northfork/mbutton.gif' width='188' height='47'><b><i><A TARGET=Inhalt HREF='URL'><FONT color=#FFFFFF> LINKNAME</A></b></i></TD></TR>";
    ($nmm_tmpl1 , $nmm_tmpl2) = split 'URL' , $nmm_tmpl, 2;
    ($nmm_tmpl2 , $nmm_tmpl3) = split 'LINKNAME' , $nmm_tmpl2, 2;
}

# Template fuer Mainmenue *aktiv* (Nav-Frame)
if($nam_tmpl eq "")
{
    # Standardtemplate
    $nam_tmpl1="<TR><TD style=\"background-image:url($nambg)\" bgcolor=\"$namc\"><b><FONT color=\"$namf\">";
    $nam_tmpl2="</FONT></b></TD><TD WIDTH=\"5\"></TD></TR>";
}
else
{
    # Skinspezifisches Template
    ($nam_tmpl1 , $nam_tmpl2) = split 'LINKNAME', $nam_tmpl, 2;
    
}

# Template fuer Submenue (Nav-Frame)
if($ns_tmpl eq "")
{
    # Standardtemplate
    $ns_tmpl1="<TR><TD WIDTH=\"100%\" nowrap bgcolor=\"$nsc\"><A TARGET=\"Hauptframe\" HREF=\"";
    $ns_tmpl2="\"><FONT color=\"$nsfc\">&#8226;";
    $ns_tmpl3="</FONT></A></TD><TD WIDTH=\"5\"></TD></tr>";
}
else
{
    # Skinspezifisches Template
    ($ns_tmpl1 , $ns_tmpl2) = split 'URL' , $ns_tmpl, 2;
    ($ns_tmpl2 , $ns_tmpl3) = split 'LINKNAME' , $ns_tmpl2, 2;
}

# Template fuer Informations

# return 1;
}



#***********************************************************
# theme_help()
# Speichert Hilfelinks in einer Variablen

sub theme_help
{
&init();
$css_help = &hlink("(CSS)", "css");

}


#**SUB******************************************************
# name: theme_version()
# info: Auslesen der Versionsnummer

sub theme_version
{
# $theme_path = './theme_gehrigal/theme.version';
$theme_path = './theme_gehrigal/theme.info'; # Since 0.32-pre3

my %hash = &filetohash("$theme_path");
$themever = $hash{themeversion}; 


}

#**SUB******************************************************
# name: string_substr
# info: Erstes Zeichen eines vorgegebenen Strings loeschen und den neuen String zurueck geben

sub string_substr
{
my $string_old = $_[0];

my $string_new = substr $string_old, 1;

return ($string_new);
}


#**SUB*****************************************************
# name: list_menu
# info: Auflisten aller moeglichen Menuepunkte

sub list_menu
{
require $wweblib;
&init_config();

# Erzeugen einer Liste mit allen Modulen


@modules = &get_available_module_infos();

#@modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;
if (@modules == 1 && $gconfig{'gotoone'}) {
	# Redirect into a single module
	&redirect($modules[0]->{'dir'}.'/');
	exit;
	}

# Schauen nach dem aktuellen Hauptmenpunkt und welche Hauptmens eigentlich zur Verfgung stehn
&ReadParse();
	&read_file("$config_directory/webmin.catnames", \%catnames);
	foreach $m (@modules) {
		$c = $m->{'category'};
		next if ($cats{$c});
		if (defined($catnames{$c})) {
			$cats{$c} = $catnames{$c};
			}
		elsif ($text{"category_$c"}) {
			$cats{$c} = $text{"category_$c"};
			}
		else {
			# try to get category name from module ..
			local %mtext = &load_language($m->{'dir'});
			if ($mtext{"category_$c"}) {
				$cats{$c} = $mtext{"category_$c"};
				}
			else {
				$c = $m->{'category'} = "";
				$cats{$c} = $text{"category_$c"};
				}
			}
		}
	@cats = sort { $b cmp $a } keys %cats;
	$cats = @cats;
	$per = $cats ? 100.0 / $cats : 100;
	if (!defined($in{'cat'})) {
		# Use default category
		if (defined($gconfig{'deftab'}) &&
		    &indexof($gconfig{'deftab'}, @cats) >= 0) {
			$in{'cat'} = $gconfig{'deftab'};
			}
		else {
			$in{'cat'} = $cats[0];
			}
		}
	elsif (!$cats{$in{'cat'}}) {
		$in{'cat'} = "";
		}


}


#**SUB******************************
#
# name: smart_uptime (a part of SMARTSTART )
# info: Uptime from System where webmin is running
#
sub smart_uptime
{
my $result;

if( !-e '/usr/bin/uptime')
    {
        $result = 'This Feature is not supported';
	    
    }
else
    {
	my $uptime = `/usr/bin/uptime`;
	$uptime =~ m/up\s+(.*?),[^,]*?user/i;
	( $uptime = $1 ) =~ tr/,//d;
					    
					    
	$result = $uptime;
    }
							
return $result;
							
}

#**SUB********************************
#
# name: getproductname
# info: Returns either 'webmin' or 'usermin' ( web-lib.pl have to be loaded)
# 		It's a copy of the orginale common function 'get_product_name', that
#		works only on the webmin platform. But i also want to use it with usermin

sub getproductname
{
return defined($gconfig{'userconfig'}) ? 'usermin' : 'webmin';
}


return 1;